jQuery(function() {
    $window = $(window);
    _nDropdownMenu();
    _nMenuAccordeon();
    _nCarousel();
    //_nPrivateMessages();
    _nCommentsSubmit();
    _nMainLoadMore();
    _nScrollTo();

    /**
     * Выпадающее меню при наведении на логотип
     * @return {Void}
     */
    function _nDropdownMenu() {
        var $menu = $('.header__nav');
        var $logo = $('.header-bar__logo');
        if (!$menu || !$logo) {
            return;
        }
        var hoverIn = function() {
            $menu.addClass('visible');
        };
        var hoverOut = function() {
            $menu.removeClass('visible');
        };
        $logo.hover(hoverIn, hoverOut);
        $menu.hover(hoverIn, hoverOut);
    }

    /**
     * Аккордеон-меню в блоке "Каталог"
     * @return {Void}
     */
    function _nMenuAccordeon() {
        var categories = $('.block_categories .block__menu');
        var buttons = $('.block_categories .block__menu-expand');
        var selected = _nCookieGet('_nAccordeonOpened');
        if (!categories) {
            return;
        }
        if (selected) {
            categories.children().each(function() {
                var li = $(this);
                var link = li.children('a');
                var id = sectionId(link.attr('href'));
                if (id == selected) {
                    li.addClass('opened');
                    link.addClass('opened');
                    var subMenu = li.children('ul');
                    if (subMenu && subMenu.length) {
                        subMenu.show();
                    }

                    return false;
                }
            });
        }
        categories.on('click', '.block__menu-expand', function() {
            var button = $(this);
            if (button.prev().hasClass('opened')) {
                close(button);
                _nCookieSet('_nAccordeonOpened', '', { expires: -1, path: '/' }); // через _nCookieDelete не работает
            } else {
                buttons.each(function(i, element) {
                    element = $(element);
                    if (element.prev().attr('href') == button.prev().attr('href')) {
                        return;
                    }
                    if (element.next('ul').is(':visible')) {
                        close(element);
                    }
                });
                open(button);
                _nCookieSet('_nAccordeonOpened', sectionId(button.prev().attr('href')), { expires: 60 * 60 * 3, path: '/' });
            }
        });

        function close(element) {
            element.prev().removeClass('opened').parent().removeClass('opened');
            element.next('ul').show().stop().slideToggle(300);
        }

        function open(element) {
            element.prev().addClass('opened').parent().addClass('opened');
            element.next('ul').hide().stop().slideToggle(300);
        }

        function sectionId(link) {
            var match = link.match(/\/[\w\d-_]+\/(\d+)/);
            if (match && match.length) {
                return match[1];
            }

            return 0;
        }
    }

    /**
     * Инициализирует плагин "карусели"
     * @return {Void}
     */
    function _nCarousel() {
        // добавляем jQuery.fn.addBack если не поддерживается (на текущей версии 1.7.2 поддержки нет, только с 1.8)
        if (!jQuery.fn.addBack) {
            jQuery.fn.addBack = jQuery.fn.andSelf;
        }
        $autoplayTimeout = 7500;
        $('.recommend__items').addClass('owl-carousel').owlCarousel({
            responsive: {
                0: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 2,
                    loop: true
                },
                480: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 3,
                    loop: true
                },
                640: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 4,
                    loop: true
                },
                768: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 5,
                    loop: true
                },
                960: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 6,
                    loop: true
                },
                1024: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 7,
                    loop: true
                },
                1260: {
                    autoplay: false,
                    items: 8,
                    loop: false,
                    mouseDrag: false
                }
            },
            margin: 26
        });
        var $owlTopGames = $('.top-game__carousel').addClass('owl-carousel').owlCarousel({
            autoHeight: true,
            items: 1,
            loop: true,
            mouseDrag: false,
            nav: true,
            navText: ['', '']
        });
        $('.top-games__nav .owl-prev').click(function () {
            $owlTopGames.trigger('prev.owl.carousel');
        });
        $('.top-games__nav .owl-next').click(function () {
            $owlTopGames.trigger('next.owl.carousel');
        });
        $('.inner-entry__related-items .uRelatedEntries').addClass('owl-carousel').owlCarousel({
            responsive: {
                0: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 2,
                    loop: true
                },
                480: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 3,
                    loop: true
                },
                640: {
                    autoplay: true,
                    autoplayHoverPause: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 4,
                    loop: true
                },
                768: {
                    autoplay: false,
                    autoplayHoverPause: false,
                    autoplayTimeout: $autoplayTimeout,
                    items: 5,
                    loop: false,
                    mouseDrag: false
                },
                1024: {
                    autoplay: true,
                    autoplayTimeout: $autoplayTimeout,
                    items: 4,
                    loop: true,
                    mouseDrag: true
                },
                1260: {
                    autoplay: false,
                    items: 5,
                    loop: false,
                    mouseDrag: false
                }
            },
            margin: 20
        });
    }

    /**
     * Подгружает количество новых ЛС
     * @return {Void}
     */
    function _nPrivateMessages() {
        var $icon = $('.header-bar__profile-pm');
        var $count = $('.header-bar__pm-count');
        var updateInterval = 180 * 1000;
        if (!$icon || !$count) {
            return;
        }
        setInterval(function() {
            $.get('/index/14', function(data) {
                var pmCount = $('b.unread', data).length;
                pmCount = +pmCount; // cast to number
                if (pmCount > 0) {
                    $icon.addClass('visible');
                    $count.addClass('visible');
                    $count.text(pmCount > 9 ? '9+' : pmCount);
                } else {
                    $icon.removeClass('visible');
                    $count.removeClass('visible');
                }
            });
        }, updateInterval);
    }

    /**
     * Обработка перед и отправка комментария
     * @return {Void}
     */
    function _nCommentsSubmit() {
        var fake = $('.comments-add__submit');
        var submit = $('.comments-add__submit_hidden');
        var textarea = $('.comments-add__text-field');
        if (!textarea || !fake || !submit) {
            return;
        }
        var minlength = 15;
        fake.click(function() {
            if (textarea.val().length < minlength) {
                _uWnd.alert('Минимальная длина комментария: ' + minlength + ' символов', 'Внимание!', {
                    w: 250,
                    h: 100,
                    name: '2w',
                    align: 'left'
                });
            } else {
                submit.click();
                var rating = $('input[name="commAddRated"]:checked');
                rating = rating && rating.length ? Math.ceil(rating.val() / 2) : null;
                if (rating) {
                    $('.u-'+(rating == 1 ? 'one' : (rating == 2 ? 'two' : (rating == 3 ? 'three' : (rating == 4 ? 'four' : 'five'))))+'-stars').click();
                }
            }
        });
    }

    /**
     * Подгрузка материалов на главной странице сайта
     * @return {Void}
     */
    function _nMainLoadMore() {
        var container = $('#allEntries');
        var button = $('.loadmore');
        var preloader = $('.preloader_loadmore');
        var pagination = $('.pagination');
        if (!container || container && !container.length || !pagination || pagination && !pagination.length) {
            return;
        }
        if (!button || button && !button.length || !preloader || preloader && !preloader.length) {
            return;
        }
        var isLastPage = $('.pagination .pagesBlockuz2 > *:last-child').hasClass('.swchItemA1');
        // если мы находимся на последней странице, то прячем кнопку
        if (isLastPage) {
            button.addClass('hidden');
            return;
        }
        var ready = true;
        var page = window._nLoadMorePage ? window._nLoadMorePage : 1;
        button.click(function() {
            if (!ready) {
                return;
            }
            ready = false;
            button.attr('disabled', 'disabled').prop('disabled', true).addClass('hidden');
            preloader.removeClass('hidden');
            $.ajax({
                type: 'GET',
                url: '/load/?page' + ++page,
                timeout: 8000,
                success: function(data) {
                    var next_pagination = $('.pagination', data);
                    isLastPage = next_pagination.find('.pagesBlockuz2').children().last().hasClass('swchItemA1');
                    container.append($('#allEntries', data).html());
                    if (!next_pagination || next_pagination && next_pagination.length == 0) {
                        button.addClass('hidden');
                    } else {
                        pagination.html(next_pagination.html());
                        button.removeAttr('disabled').prop('disabled', false).removeClass('hidden');
                    }
                    preloader.addClass('hidden');
                    if (isLastPage) {
                        button.addClass('hidden');
                    }
                    // синхронизируем кнопки-закладки и добавляем им поведение при клике
                    if (window._nUID && _nBookmarksInitControls) {
                        _nBookmarksInitControls();
                        _nBookmarksControlsSync();
                        _nBookmarksControlsEnabled(_nBookmarksReady);
                    }
                    ready = true;
                },
                error: function(request, status, err) {
                    if(status == "timeout") {
                        _uWnd.alert('Превышено время выполнения запроса.', 'Внимание', { w: 250, h: 92, tm: 3500 });
                    } else {
                        _uWnd.alert('При выполнении запроса произошла ошибка.', 'Внимание', { w: 250, h: 92, tm: 3500 });
                    }
                    button.removeClass('hidden');
                    preloader.addClass('hidden');
                    page--;
                    ready = true;
                }
            });
        });
    }

    /**
     * Выполняет плавную прокрутку к блоку по ссылке-якорю
     * @return {Void}
     */
    function _nScrollTo() {
        var links = $('a[href^=#]');
        if (!links || links && !links.length) {
            return;
        }
        var header = $('.header__bar-wrapper');
        var moderpanel = $('#puzadpn');
        var root = $('html, body');
        header = header && header.length ? header : null;
        moderpanel = moderpanel && moderpanel.length ? moderpanel : null;
        links.each(function() {
            var self = $(this);
            var block = $(self.attr('href'));
            if (!block || block && !block.length) {
                return;
            }
            self.click(function(event) {
                event = event || window.event;
                event.preventDefault();
                root.stop().animate({
                    scrollTop: block.offset().top - (header ? header.outerHeight() : 0) - (moderpanel ? moderpanel.outerHeight() : 0) - 10
                }, 350);
            });
        });
    }

    /**
     * Получает значение cookie
     * @param {String} name - название cookie
     * @return {String}
     */
    function _nCookieGet(name) {
        var matches = document.cookie.match(new RegExp("(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"));

        return matches ? decodeURIComponent(matches[1]) : undefined;
    }

    /**
     * Устанавливает cookie
     * @param {String} name - название cookie
     * @param {String} value - значение cookie
     * @param {Object[]} options - настройки
     * @return {Void}
     */
    function _nCookieSet(name, value, options) {
        options = options || {};
        var expires = options.expires;
        if (typeof expires == "number" && expires) {
            var d = new Date();
            d.setTime(d.getTime() + expires * 1000);
            expires = options.expires = d;
        }
        if (expires && expires.toUTCString) {
            options.expires = expires.toUTCString();
        }
        value = encodeURIComponent(value);
        var updatedCookie = name + "=" + value;
        for (var propName in options) {
            updatedCookie += "; " + propName;
            var propValue = options[propName];
            if (propValue !== true) {
                updatedCookie += "=" + propValue;
            }
        }
        document.cookie = updatedCookie;
    }

    /**
     * Удаляет cookie
     * @param {String} name - название cookie
     * @return {Void}
     */
    function _nCookieDelete(name) {
        _nCookieSet(name, '', { expires: -1 });
    }

});