/**
 * Плагин окна с видеоплеером. Необходимо подключение jquery.jplayer.min.js
 * @author N-Torrents.ru <feniwe@gmail.com>
 * @version 1.0
 */

jQuery(function () {
    $.fn.video = function (options) {
        return this.each(function () {
            var $this = $(this);
            if (!settings) {
                var settings = {};
                settings = $.extend({
                    adv: 'http://n-torrents.ru/rtr/1-18', // источник, откуда тянуть скрипт и код с рекламой
                    duration: 15, // продолжительность показа рекламы
                    autoplay: true, // автозапуск jPlayer'а при закрытии рекламы
                    content: player,
                    custom: false, // является ли содержимое блока нестандартным (вставка другого кода, а не одного из предусмотреных видеоплееров)
                    url: null, // ссылка на трейлер
                    video: null, // ссылка на видеофайл
                    preview: null // ссылка на фоновое изображение до запуска плеера
                }, options);
            }
            if (!settings.custom) {
                normalize();
            }
            var interval = null;
            var left = settings.duration;

            $this.click(function () {
                if (!settings.url && !settings.custom) {
                    return;
                }
                $('body').prepend('<div class="video-popup"><div class="video-popup__wrapper"><button type="button" class="video-popup__close"></button><div class="video-popup__content aspect-ratio aspect-ratio_16x9">' + (settings.custom || !settings.custom && !ownPlayerRequired() ? settings.content() : '') + '</div></div></div>');
                $('.video-popup').addClass('visible');
                $('.video-block').on('mousewheel DOMMouseScroll', function (event) {
                    event.preventDefault();
                });
                $('.video-popup__close').click(function () {
                    if (interval != null) {
                        clearInterval(interval);
                    }
                    $('.video-popup').replaceWith('');
                });
                if (settings.adv && settings.duration > 0 && left > 0) {
                    left = settings.duration;
                    $('.video-popup__content').append('<div class="video-popup__adv"><div class="video-popup__adv-content"></div><button type="button" class="video-popup__adv-close button_green">Осталось: ' + left + ' сек.</button></div>');
                    var $close = $('.video-popup__adv-close');
                    fetchAdv();
                    interval = setInterval(function () {
                        left--;
                        if (left <= 0) {
                            clearInterval(interval);
                            $close.text('Пропустить рекламу');
                            $close.click(function () {
                                $('.video-popup__adv').replaceWith('');
                            });
                        } else {
                            $close.text('Осталось: ' + left + ' сек.');
                        }
                    }, 1000);
                }
                // ситуация, когда трубется обработка других плееров рассмотрена в строке 31
                if (!settings.custom && ownPlayerRequired()) {
                    if (settings.video && settings.preview) {
                        ownPlayer();
                    } else {
                        fetchVideoData();
                    }
                }
            });

            /**
             * Приводит ссылку на видео к необходимому виду
             */
            function normalize() {
                if (!settings.url) {
                    return;
                }
                if (settings.url.search(/kinopoisk[.]ru\/film\/\d+/) != -1) {
                    settings.url = 'https://www.' + settings.url.match(/kinopoisk[.]ru\/film\/\d+/)[0] + '/video/';
                } else if (settings.url.search(/youtube[.]com\/watch[?]v=(.+)/) != -1) {
                    settings.url = 'http://www.youtube.com/embed/' + settings.url.match(/youtube[.]com\/watch[?]v=(.+)/)[1] + '?fs=1';
                }
            }

            /**
             * Получает и вставляет код рекламы
             */
            function fetchAdv() {
                $.ajax({
                    url: settings.adv,
                    type: 'GET',
                    dataType: 'text',
                    success: function (response) {
                        response = response.substring(16, response.length - 3);
                        response = response.replace(/\\"'/g, '"');
                        response = response.replace(/\\'/g, '\'');
                        response = response.replace(/<hr ?\/?>/g, '');
                        if ($('.video-popup__adv-content')) {
                            $('.video-popup__adv-content').html(response);
                        }
                    }
                });
            }

            /**
             * Определяет нужно ли выводить свой плеер
             */
            function ownPlayerRequired() {
                if (!settings.url) {
                    return false;
                }

                return settings.url.search(/kinopoisk[.]ru\/film\/\d+/) != -1;
            }

            /**
             * Получает данные о видео с КиноПоиска
             */
            function fetchVideoData() {
                $.ajax({
                    url: 'http://n-torrents.com/v3/kinopoisk_trailer.php',
                    type: 'GET',
                    data: 'address=' + settings.url,
                    dataType: 'text',
                    success: function (response) {
                        var json = JSON.parse(response);
                        settings.video = json.video;
                        settings.preview = json.preview;
                        if (settings.video && settings.video !== '') {
                            // ownPlayer();
                            // обрабатываем ссылку на видеофайл, возможно, что придёт ссылка на youtube-плеер
                            if (settings.video.search(/kinopoisk[.]ru/) != -1) {
                                ownPlayer();
                            } else {
                                settings.url = settings.video;
                                normalize();
                                $('.video-popup__content').html(settings.content());
                            }
                        } else {
                            ownPlayerError('not-available');
                        }
                    },
                    error: function (error) {
                        console.log('Error: ' + error.status + ' ' + error.responseText);
                        ownPlayerError('loading-error');
                    }
                });
            }

            /**
             * Возвращает html код видеоплеера
             */
            function player() {
                if (!settings.url) {
                    return '';
                }
                if (settings.url.indexOf('youtube.com') != -1) {
                    return '<iframe width="720" height="405" src="' + settings.url + '" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowfullscreen></iframe>';
                } else if (settings.url.indexOf('rutube.ru') != -1) {
                    return '<iframe width="720" height="405" src="' + settings.url + '" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowfullscreen></iframe>';
                } else {
                    return '<div class="video-popup__jp-video jp-video" role="application" aria-label="media player"><div class="jp-type-single"><div class="jp-video-play"><span class="jp-video-play-icon" role="button" tabindex="0"></span></div><div class="jp-jplayer"></div><div class="jp-no-solution"><p>Не удалось воспроизвести видео по одной из возможных причин:</p><ul><li class="jp-video__not-supported">Вашему браузеру необходимо обновиться до последней версии</li><li class="jp-video__not-supported">Устаревшая версия <a href="http://get.adobe.com/flashplayer/" target="_blank" rel="nofollow">Adobe Flash Player</a></li><li class="jp-video__not-available" style="display: none;">Отсутствует ссылка на видео файл</li><li class="jp-video__loading-error" style="display: none;">Не удалось получить ссылку на видео файл. Попробуйте перезагрузить страницу.</li></ul></div><div class="jp-gui"><button class="jp-play" role="button" tabindex="0"></button><button class="jp-stop" role="button" tabindex="0"></button><div class="jp-progress"><div class="jp-seek-bar"><div class="jp-play-bar"></div></div></div><div class="jp-time-container"><span class="jp-current-time" role="timer" aria-label="time">00:00</span><span class="jp-duration" role="timer" aria-label="duration">00:00</span></div><button class="jp-mute" role="button" tabindex="0"></button><div class="jp-volume-bar"><div class="jp-volume-bar-value"></div></div><button class="jp-full-screen" role="button" tabindex="0"></button></div></div></div>';
                }
            }

            /**
             * Инициализирует видеоплеер
             */
            function ownPlayer() {
                $('.video-popup__content').append(player());
                $('.video-popup__jp-video .jp-jplayer').jPlayer({
                    ready: function () {
                        $(this).jPlayer('setMedia', mediaObject());
                    },
                    globalVolume: true,
                    cssSelectorAncestor: '.video-popup__jp-video',
                    size: {
                        width: 720,
                        height: 405
                    },
                    swfPath: '/jplayer',
                    supplied: suppliedFormat(),
                    useStateClassSkin: true,
                    autoBlur: false,
                    keyEnabled: true
                });
                if (settings.autoplay) {
                    $('.jp-video').jPlayer('play');
                }
            }

            /**
             * Возвращает объект с данными для видеоплеера
             */
            function mediaObject() {
                if (settings.video.slice(-4) == '.flv')
                    return {flv: settings.video, poster: settings.preview}
                else
                    return {m4v: settings.video, poster: settings.preview}
            }

            /**
             * Возвращает строку с форматом для видеофайла
             */
            function suppliedFormat() {
                if (settings.video.slice(-4) == '.flv') {
                    return 'flv';
                }

                return 'm4v';
            }

            /**
             * Отображает ошибку при воспроизведении видео
             *
             * @param {string} error - тип ошибки
             */
            function ownPlayerError(error) {
                $('.jp-no-solution').show();
                switch (error) {
                    case 'not-supported':
                        $('.jp-video__not-supported').show();
                        $('.jp-video__not-available, .jp-video__loading-error').hide();
                        break;
                    case 'not-available':
                        $('.jp-video__not-available').show();
                        $('.jp-video__not-supported, .jp-video__loading-error').hide();
                        break;
                    case 'loading-error':
                        $('.jp-video__loading-error').show();
                        $('.jp-video__not-available, .jp-video__not-supported').hide();
                        break;
                }
            }

            /**
             * Считает хеш для набора настроек
             */
            /*function hash() {
                var str = '';
                var hash = 0;
                for (var key in settings) {
                    str += key + '=' + settings['key'];
                }
                if (str.length == 0) {
                    return hash;
                }
                for (var i = 0; i < str.length; i++) {
                    var char = this.charCodeAt(i);
                    hash = ((hash << 5) - hash) + char;
                    hash = hash & hash; // Convert to 32bit integer
                }

                return hash;
            }*/
        });
    };
});