/**
 * Основные скрипты сайта. Не имеет зависимостей (возможна подгрузка файла с аттрибутом async или defer)
 * @author N-Torrents.ru <feniwe@gmail.com>
 * @version 1.0
 */

var _nClosables = []; // масив объектов с информацией о скрываемых элементах при клике вне их области
var _nTouchDelta = 0;
var _nPrevTouchDelta = 0;
var _nMenuContent;
var _nMenuOverlay;
var _nCssProperties = {
    'transform': ['transform', 'msTransform', 'MozTransform', 'WebkitTransform', 'OTransform'],
    'transition': ['transition', 'msTransition', 'MozTransition', 'WebkitTransition', 'OTransition'],
};

// инициализация
init();

/**
 * Инициализатор js-функционала
 * @return {Void}
 */
function init() {
    var functions = [
        _nPolyfills,           // держать всегда вверху, все необходимые полифиллы должны быть инициализированы заранее
        _nCookieReset,         // удаление cookie при загрузке страницы
        _nStickyHeader,        // меняет положение шапки сайта при прокрутке
        _nMobileMenu,          // поведение мобильного меню
        _nMiniProfile,         // поведение мини-профиля
        _nTabs,                // переключатели блоков под шапкой сайта (РЕКОМЕНДУЕМ:)
        _nSpoilersFix,         // удалет из спойлеров мусор
        _nReplaceRespectTag,   // заменяет тег $RESPEKT$
        _nInsertRespectButton, // добавляет кнопку для вставки тега $RESPEKT$
        _nInitCommentsQuote,   // цитирование комментариев
        _nInitCommentRating,   // оценка раздачи в форме добавления комментария
        _nShortCommSubscribe,  // урезает текст пунктов выпадающего списка подписки в форме добавления комментария
        _nSelectsDefaultsFix,  // поправляет дефолтные значения select'ов
        _nSelectBoxes,         // select'ы
        _nFaqEntries,          // поведение материалов модуля FAQ
        _nPlaceholders,        // проставляет placeholder'ы или схожее поведение
        _nKinopoiskRating,     // подгружает рейтинг кинопоиска
        _nAnotherQuality,      // поиск похожих материалов (в другом качестве)
        _nAccordeon,           // accordeon-поведение (классы у кнопки js_accordeon-trigger js_accordeon-trigger_модификатор, у контейнера js_accordeon-container js_accordeon-container_модификатор)
        _nPopups,              // желательно держать внизу, т.к. в скриптах выше могут добавляться Popup'ы, как в _nAnotherQuality
        _nTorrentFetchData,    // получение статистики раздач и списка файлов раздачи
    ];
    for (var i = 0; i < functions.length; i++) {
        try {
            functions[i]();
        } catch (exception) {
            console.dir(exception);
        }
    }
    document.onclick = _nDocumentClickFn;
}

/**
 * Полифиллы
 * @return {Void}
 */
function _nPolyfills() {
    if (!String.prototype.trim) {
        String.prototype.trim = function() {
            return this.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
        };
    }
    if ( (!document.addEventListener) && document.attachEvent ) {
        Object.defineProperty(Element.prototype, 'addEventListener', function(eventName, func) {
            var self = this;
            self['e' + eventName + func] = fn;
            self[eventName + func] = function() {
                obj['e' + eventName + func]( window.event );
            };
            self.attachEvent('on' + eventName, self[eventName + func] );
        });
    }
    if (!('classList' in Element.prototype)) {
        var testRegExp = function(name) {
            return new RegExp('(^| )'+ name +'( |$)');
        };
        var forEach = function(list, fn, scope) {
            for (var i = 0; i < list.length; i++) {
                fn.call(scope, list[i]);
            }
        };
        function ClassList(element) {
            this.element = element;
        }
        ClassList.prototype = {
            add: function() {
                forEach(arguments, function(name) {
                    if (!this.contains(name)) {
                        this.element.className += ' ' + name;
                    }
                }, this);
                this.element.className = this.element.className.trim();
            },
            remove: function() {
                forEach(arguments, function(name) {
                    this.element.className = this.element.className.replace(testRegExp(name), ' ').trim();
                }, this);
            },
            toggle: function(name) {
                return this.contains(name) ? (this.remove(name), false) : (this.add(name), true);
            },
            contains: function(name) {
                return testRegExp(name).test(this.element.className);
            }
        };
        Object.defineProperty(Element.prototype, 'classList', {
            get: function() {
                return new ClassList(this);
            }
        });
    }
    if (!Array.prototype.forEach) {
        Array.prototype.forEach = function (callback, thisArg) {
            var T, k;
            if (this == null) {
                throw new TypeError(' this is null or not defined');
            }
            var O = Object(this);
            var len = O.length >>> 0;
            if (typeof callback !== 'function') {
                throw new TypeError(callback + ' is not a function');
            }
            if (arguments.length > 1) {
                T = thisArg;
            }
            k = 0;
            while (k < len) {
                var kValue;
                if (k in O) {
                    kValue = O[k];
                    callback.call(T, kValue, k, O);
                }
                k++;
            }
        };
    }
    if (!Array.prototype.map) {
        Array.prototype.map = function(callback, thisArg) {
            var T, A, k;
            if (this == null) {
                throw new TypeError(' this is null or not defined');
            }
            var O = Object(this);
            var len = O.length >>> 0;
            if (typeof callback !== 'function') {
                throw new TypeError(callback + ' is not a function');
            }
            if (arguments.length > 1) {
                T = thisArg;
            }
            A = new Array(len);
            k = 0;
            while (k < len) {
                var kValue, mappedValue;
                if (k in O) {
                    kValue = O[k];
                    mappedValue = callback.call(T, kValue, k, O);
                    A[k] = mappedValue;
                }
                k++;
            }

            return A;
        };
    }
    if (!Array.prototype.find) {
        Array.prototype.find = function(predicate) {
            if (this == null) {
                throw new TypeError('Array.prototype.find called on null or undefined');
            }
            if (typeof predicate !== 'function') {
                throw new TypeError('predicate must be a function');
            }
            var list = Object(this);
            var length = list.length >>> 0;
            var thisArg = arguments[1];
            var value;
            for (var i = 0; i < length; i++) {
                value = list[i];
                if (predicate.call(thisArg, value, i, list)) {
                    return value;
                }
            }

            return undefined;
        };
    }
    if (!Array.prototype.some) {
        Array.prototype.some = function(fun/*, thisArg*/) {
            'use strict';
            if (this == null) {
                throw new TypeError('Array.prototype.some called on null or undefined');
            }
            if (typeof fun !== 'function') {
                throw new TypeError();
            }
            var t = Object(this);
            var len = t.length >>> 0;
            var thisArg = arguments.length >= 2 ? arguments[1] : void 0;
            for (var i = 0; i < len; i++) {
                if (i in t && fun.call(thisArg, t[i], i, t)) {
                    return true;
                }
            }

            return false;
        };
    }
    if (!Array.prototype.reduce) {
        Array.prototype.reduce = function(callback/*, initialValue*/) {
            'use strict';
            if (this == null) {
                throw new TypeError('Array.prototype.reduce called on null or undefined');
            }
            if (typeof callback !== 'function') {
                throw new TypeError(callback + ' is not a function');
            }
            var t = Object(this), len = t.length >>> 0, k = 0, value;
            if (arguments.length >= 2) {
                value = arguments[1];
            } else {
                while (k < len && ! (k in t)) {
                    k++;
                }
                if (k >= len) {
                    throw new TypeError('Reduce of empty array with no initial value');
                }
                value = t[k++];
            }
            for (; k < len; k++) {
                if (k in t) {
                    value = callback(value, t[k], k, t);
                }
            }

            return value;
        };
    }
    if (!Array.prototype.indexOf) {
        Array.prototype.indexOf = function(searchElement, fromIndex) {
            var k;
            if (this == null) {
                throw new TypeError('"this" is null or not defined');
            }
            var O = Object(this);
            var len = O.length >>> 0;
            if (len === 0) {
                return -1;
            }
            var n = +fromIndex || 0;
            if (Math.abs(n) === Infinity) {
                n = 0;
            }
            if (n >= len) {
                return -1;
            }
            k = Math.max(n >= 0 ? n : len - Math.abs(n), 0);
            while (k < len) {
                if (k in O && O[k] === searchElement) {
                    return k;
                }
                k++;
            }

            return -1;
        };
    }
    if (!Object.assign) {
        Object.assign = function assign(target, source) {
            for (var index = 1, key, src; index < arguments.length; ++index) {
                src = arguments[index];
                for (key in src) {
                    if (Object.prototype.hasOwnProperty.call(src, key)) {
                        target[key] = src[key];
                    }
                }
            }

            return target;
        };
    }
    if (!window.requestAnimationFrame) {
        (function() {
            var lastTime = 0;
            var vendors = ['ms', 'moz', 'webkit', 'o'];
            for(var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
                window.requestAnimationFrame = window[vendors[x]+'RequestAnimationFrame'];
                window.cancelAnimationFrame = window[vendors[x]+'CancelAnimationFrame']
                    || window[vendors[x]+'RequestCancelAnimationFrame'];
            }
            if (!window.requestAnimationFrame || !window.cancelAnimationFrame) { // Chrome (16) supports request but not cancel
                window.requestAnimationFrame = function (callback, element) {
                    var currTime = new Date().getTime();
                    var timeToCall = Math.max(0, 16 - (currTime - lastTime));
                    var id = window.setTimeout(function () {
                        callback(currTime + timeToCall);
                    }, timeToCall);
                    lastTime = currTime + timeToCall;

                    return id;
                };
                if (!window.cancelAnimationFrame) {
                    window.cancelAnimationFrame = function (id) {
                        clearTimeout(id);
                    };
                }
            }
        }());
    }
    if (!Date.now) {
        Date.now = function now() {
            return new Date().getTime();
        };
    }
}

/**
 * Прикрепляет шапку к верху страницы
 * @return {Void}
 */
function _nStickyHeader() {
    var scrolled = 0;
    var header = document.querySelector('.header');
    var headerMenu = document.querySelector('.header__nav');
    var headerBar = document.querySelector('.header__bar-wrapper');
    var menuScrollOffset = 46;
    if (!header || !headerMenu || !headerBar) {
        return;
    }
    window.addEventListener('scroll', function() {
        scrolled = window.pageYOffset || (document.documentElement && document.documentElement.scrollTop);
        if (scrolled >= menuScrollOffset) {
            header.classList.add('sticky-background');
            headerBar.classList.add('sticky');
            headerMenu.classList.add('dropdown');
        } else {
            header.classList.remove('sticky-background');
            headerBar.classList.remove('sticky');
            headerMenu.classList.remove('dropdown');
        }
    });
}

/**
 * Открытие и закрытие модальных окон
 * @return {Void}
 */
function _nPopups() {
    var popups = document.querySelectorAll('.popup');
    if (!popups) {
        return;
    }
    // клик по окну вне области контента и контроль прокрутки
    for (var i = 0; i < popups.length; i++) {
        _nPopupBehavior(popups[i]);
    };
    // кнопки открытия окон
    var buttons = document.querySelectorAll('.popup-open');
    if (!buttons || !buttons.length) {
        return;
    }
    for (var i = 0; i < buttons.length; i++) {
        _nPopupBindOpen(buttons[i]);
    }
}

/**
 * Задает обработчик открытия popup-окна по клику на кнопку button
 * @param {Object} button - dom-объект
 * @param {Function} callback
 * @return {Void}
 */
function _nPopupBindOpen(button, callback) {
    var popup;
    var match = button.className.match(/popup[-]open_([\w\d-]+)/);
    if (match && match.length) {
        popup = document.querySelector('.popup_' + match[1]);
    }
    button.addEventListener('click', function(event) {
        event = event || window.event;
        event.preventDefault();
        if (popup) {
            popup.classList.add('visible');
            if (typeof callback !== 'function') {
                return;
            }
            callback();
        }
    });
}

/**
 * Активирует функционал закрытия и прокрутки popup окна
 * @param {Object} popup - dom-объект
 * @return {Void}
 */
function _nPopupBehavior(popup) {
    _nControlScroll(popup);
    popup.addEventListener('click', function(e) {
        var event = e || window.event;
        var target = event.target || event.srcElement;
        if (target.classList.contains('popup')) { // клик вне области контента, а по темному фону
            this.classList.remove('visible');
        }
    });
    var close = popup.querySelector('.popup__close');
    if (close) {
        close.addEventListener('click', function() {
            if (popup.classList.contains('popup')) {
                popup.classList.remove('visible');
            }
        });
    }
}

/**
 * Активирует функционал бокового меню на смартфонах и планшетах
 * @return {Void}
 */
function _nMobileMenu() {
    var menu = document.querySelector('.nav-drawer');
    _nMenuOverlay = document.querySelector('.nav-overlay');
    _nMenuContent = document.querySelector('.nav-drawer__content');
    var button = document.querySelector('.header-bar__menu-button');
    if (!menu || !_nMenuOverlay || !_nMenuContent || !button) {
        return;
    }
    // запрещаем прокрутку перекрывающего элемента
    _nDenyScroll(_nMenuOverlay);
    // контролируем прокрутку содержимого
    _nControlScroll(_nMenuContent);
    var startX, startY, menuWidth = menu.offsetWidth;
    var opened = false;
    var swipeArea = 96;
    var moveTime;

    button.addEventListener('click', open);
    _nMenuOverlay.addEventListener('click', function (e) {
        var event = e || window.event;
        var path = _nGetEventPath(event);
        for (var i = 0; i < path.length; i++) {
            if (path[i] === menu) {
                return;
            }
        }
        close();
    });

    window.addEventListener('touchstart', function (e) {
        var event = e || window.event;
        startX = event.touches[0].clientX;
        startY = event.touches[0].clientY;
        moveTime = (new Date()).getTime();
    });

    window.addEventListener('touchmove', function (e) {
        var event = e || window.event;
        var path = _nGetEventPath(event);
        for (var i = 0; i < path.length; i++) {
            if (path[i].className && path[i].className.indexOf('owl-carousel') != -1) {
                return;
            }
        }
        // если меню закрыто, и мы выполняем жест открытия вне прослушиваемой области
        if (!opened && startX > swipeArea) {
            return;
        }
        // если делаем свайп влево и меню открыто, но палец движется вверх более, чем на 50px, то завешаем event
        if (Math.abs(event.changedTouches[0].clientY - startY) > 50 && opened) {
            return;
        }
        var diff = event.changedTouches[0].clientX - startX;
        var moveSpeed = Math.abs(((new Date()).getTime() - moveTime) / diff);
        if (moveSpeed > 5) {
            return;
        }
        if (opened) {
            diff > -menuWidth / 3 ? open() : close();
        } else {
            diff > menuWidth / 3 ? open() : close();
        }
        event.preventDefault();
    });

    /**
     * Открывает меню
     * @return {Void}
     */
    function open() {
        menu.classList.add('visible');
        _nMenuOverlay.classList.add('visible');
        opened = true;

        return false;
    }

    /**
     * Закрывает меню
     * @return {Void}
     */
    function close() {
        menu.classList.remove('visible');
        _nMenuOverlay.classList.remove('visible');
        opened = false;

        return false;
    }
}

/**
 * Выпадающее меню мини-профиля
 * @return {Void}
 */
function _nMiniProfile() {
    var buttons = document.querySelectorAll('.header-bar__profile-name');
    var menus = document.querySelectorAll('.header-bar__profile-menu');
    if (!buttons || !menus) {
        return;
    }
    for (var i = 0; i < buttons.length; i++) {
        buttons[i].addEventListener('click', function() {
            var menu = this.nextElementSibling;
            if (!menu) {
                return;
            }
            if (this.classList.contains('opened')) {
                this.classList.remove('opened');
                menu.classList.remove('visible');
            } else {
                this.classList.add('opened');
                menu.classList.add('visible');
            }
            _nRegisterAsCloseable(menu, this, 'visible', 'opened');
        });
    }
}

/**
 * Табулятор под шапкой
 * Для первого контейнера с материалами поддерживается аттрибут data-cookie-mode, служащий уникальным ключом,
 * благодаря которому можно запоминать последнюю открытую вкладку в разных разделах сайта
 * @return {Void}
 */
function _nTabs() {
    var buttons = document.querySelectorAll('.recommend__switch');
    var blocks = document.querySelectorAll('.recommend__tab-content');
    if (!buttons || !blocks) {
        return;
    }
    var cookieMode = null;
    if (blocks[0].getAttribute('data-cookie-mode')) {
        cookieMode = blocks[0].getAttribute('data-cookie-mode');
    }
    if (_nCookieGet('_nTab' + (cookieMode ? '_' + cookieMode : ''))) {
        var selected = parseInt(_nCookieGet('_nTab' + (cookieMode ? '_' + cookieMode : '')));
        if (selected > buttons.length - 1 || selected < 0) {
            selected = 0;
        }
        if (selected > 0) {
            buttons[0].classList.remove('active');
            blocks[0].classList.remove('visible');
            buttons[selected].classList.add('active');
            if (blocks[selected]) {
                blocks[selected].classList.add('visible');
            }
        }
    }
    for (var i = 0; i < buttons.length; i++) {
        buttons[i].addEventListener('click', function() {
            if (this.classList.contains('active')) {
                return;
            }
            var index = 0;
            for (var j = 0; j < buttons.length; j++) {
                if (this == buttons[j]) {
                    index = parseInt(j);
                }
                buttons[j].classList.remove('active');
            }
            for (var j = 0; j < blocks.length; j++) {
                blocks[j].classList.remove('visible');
            }
            buttons[index].classList.add('active');
            if (blocks.length > index) {
                blocks[index].classList.add('visible');
            }
            var date = new Date;
            _nCookieSet('_nTab' + (cookieMode ? '_' + cookieMode : ''), index, { expires: 60 * 60 * 24 * 30, path: '/' });
        });
    }
}

/**
 * Убирает [+] и [-] у спойлеров
 * @return {Void}
 */
function _nSpoilersFix() {
    var spoilers = document.querySelectorAll('.uSpoilerButton');
    if (!spoilers) {
        return;
    }
    for (var i = 0; i < spoilers.length; i++) {
        var onclickAttr = spoilers[i].getAttribute('onclick');
        onclickAttr = onclickAttr.replace(/[[]([+]|\\–)] ?/g, '');
        spoilers[i].setAttribute('onclick', onclickAttr);
        spoilers[i].value = spoilers[i].value.replace(/[[]([+]|\\–)] ?/g, '');
    }
}

/**
 * Заменяет тег $RESPEKT$ на HTML-код
 * @return {Void}
 */
function _nReplaceRespectTag() {
    var comments = document.querySelectorAll('.comment .comment__text');
    if (!comments || comments && comments.length == 0) {
        return;
    }
    for (var i = 0; i < comments.length; i++) {
        comments[i].innerHTML = comments[i].innerHTML.replace(/\$RESPEKT\$/gi, '<div class="comment__respect"><img src="http://n-torrents.ru/smiles/smile.gif" height="16" width="16" alt="smile"><div class="comment__respect-text">Уважаемый, <span class="bold">раздающий</span>! Эта раздача просто великолепна! Большое спасибо!</div></div>');
    }
}

/**
 * Добавляет кнопку для вставки $RESPEKT$ в поле ввода комментария
 * @return {Void}
 */
function _nInsertRespectButton() {
    var bbEditor = document.querySelector('.comments-add__bbcodes.ucoz-editor-panel');
    if (!bbEditor) {
        return;
    }
    var closeAll = bbEditor.querySelector('.codeCloseAll');
    if (closeAll) {
        closeAll.insertAdjacentHTML('beforebegin', '<span><input type="button" value="respect" title="Поблагодарить автора" onclick="doInsert(\'$\' + \'RESPEKT\' + \'$\', \'\', false, \'message\');"></span>');
    }
}

/**
 * Цитирование комментариев
 * @return {Void}
 */
function _nInitCommentsQuote() {
    var quoteButtons = document.querySelectorAll('.comment .comment__quote');
    if (!quoteButtons) {
        return;
    }
    for (var i = 0; i < quoteButtons.length; i++) {
        quoteButtons[i].addEventListener('click', function(event) {
            event = event || window.event;
            event.preventDefault();
            var parent = this.parentNode.parentNode;
            var text = parent.querySelector('.comment__text');
            var author = parent.querySelector('.comment__author a');
            var field = document.getElementById('message');
            if (!text || !author || !field) {
                return;
            }
            if (_nFilterQuoteText(text.innerHTML) == '')
            {
                return;
            }
            field.value += '[quote=' + author.innerText.trim() + ']' + _nFilterQuoteText(text.innerHTML).trim() + '[/quote]\n';
            field.focus();
        });
    }
}

/**
 * Фильтрует цитируемый текст
 * @param {String} text - цитируемый текст
 * @return {String}
 */
function _nFilterQuoteText(text) {
    if (typeof text !== 'string' && typeof text !== 'number') {
        return '';
    }
    text = text.replace(/[\[\]]/g, '¦');
    text = text.replace(/<\/?br\s*\/?>/g, '\r\n');
    text = text.replace(/<img .*?"\s*\/?>/gi, '');
    text = text.replace(/<!--uzquote-->(.*?)<!--\/uzquote-->( |<br ?\/?>)*/gm, '');

    return text;
}

/**
 * Укорачивает названия опций select'а с выбором подписки (на ответы и комментарии) в форме добавления комментария
 * @return {Void}
 */
function _nShortCommSubscribe() {
    var select = document.querySelector('.comments-add__subscribe select');
    if (select && select.options && select.options.length >= 3) {
        select.options[0].innerHTML = 'Без подписки';
        select.options[1].innerHTML = 'Комментарии';
        select.options[2].innerHTML = 'Ответы';
    }
}

/**
 * Создает каркас для оценки раздачи из формы добавления комментария
 * @return {Void}
 */
function _nInitCommentRating() {
    var rating = document.querySelector('.comments-add__rate-items');
    var submit = document.querySelector('.comments-add__submit_hidden');
    if (!rating || !submit) {
        return;
    }
    var ratingItems = '';
    for (var i = 1; i <= 10; i++) {
        ratingItems += '<input type="radio" name="commAddRated" value="' + i + '" id="commAddRated' + i + '"><label for="commAddRated' + i + '"></label>';
    }
    rating.innerHTML = ratingItems;
    submit.setAttribute('onclick', '_nInsertCommentRating();');
}

/**
 * Добавляет спец. последовательность символов в <textarea name="message"> для оценки из комментария
 * @return {Void}
 */
function _nInsertCommentRating() {
    var rating = document.querySelectorAll('.comments-add__rate-items input[name="commAddRated"]');
    var textarea = document.querySelector('.comments-add__text-field');
    if (!rating || !textarea) {
        return;
    }
    var replacement = '';
    for (var i = 0; i < rating.length; i++) {
        if (rating[i].checked) {
            replacement = '===' + rating[i].value;
            break;
        }
    }
    var value = textarea.value;
    if (/===\d+/g.test(value)) {
        value = value.replace(/ *===(\d+) */, replacement);
    } else {
        value += replacement;
    }
    textarea.value = value;
}

/**
 * Сворачивает - разворачивает материалы модуля FAQ
 * @return {Void}
 */
function _nFaqEntries() {
    var faqButtons = document.querySelectorAll('.faq-entry__title');
    if (!faqButtons) {
        return;
    }
    for (var i = 0; i < faqButtons.length; i++) {
        faqButtons[i].addEventListener('click', function() {
            if (this.parentNode.classList.contains('opened')) {
                this.parentNode.classList.remove('opened');
            } else {
                this.parentNode.classList.add('opened');
            }
        });
    }
}

/**
 * Задает либо аттрибут placeholder, либо схожее поведение
 * @return {Void}
 */
function _nPlaceholders() {
    var fields = [
        {
            selector: '.header-bar__search-input',
            placeholder: 'Поиск по торрентам...'
        },
        {
            selector: '.registration-form__field_login input',
            placeholder: 'Логин *'
        },
        {
            selector: '.registration-form__field_email input',
            placeholder: 'E-Mail адрес *'
        },
        {
            selector: '.registration-form__field_name input',
            placeholder: 'Имя *'
        },
        {
            selector: '.registration-form__field_password input',
            placeholder: 'Пароль *'
        },
        {
            selector: '.registration-form__field_password-confirm input',
            placeholder: 'Пароль (подтверждение) *'
        },
        {
            selector: '.header-bar__search-input',
            placeholder: 'Поиск по торрентам...'
        },
        {
            selector: 'input[name="mcmessage"]',
            placeholder: window._nUID ? 'Отправить сообщение' : 'Авторизуйтесь для отправки сообщения'
        }
    ];
    var placeholderAvailable = 'placeholder' in document.createElement('input');
    for (var i = 0; i < fields.length; i++) {
        var input = document.querySelector(fields[i].selector);
        if (!input) {
            continue;
        }
        if (placeholderAvailable) {
            input.setAttribute('placeholder', fields[i].placeholder);
        } else {
            input.setAttribute('onblur', 'if (value == \'\') {value = \'' + fields[i].placeholder + '\'}');
            input.setAttribute('onfocus', 'if (value == \'' + fields[i].placeholder + '\') {value =\'\'}');
        }
        // фокусировка и сброс фокуса для ie9 (иначе не появляются placeholder'ы)
        if (!placeholderAvailable && input.focus && input.onblur) {
            input.focus();
            input.onblur();
        }
    }
}

/**
 * Выполняет запрос на получение статистики раздачи
 * TODO: Для выполнения необходимо перед вызовом объявить в document два свойства
 * @return {Void}
 */
function _nTorrentFetchData() {
    if (!window._nTorrentFolderId || !window._nTorrentFileName) {
        return;
    }
    var XHR = ("onload" in new XMLHttpRequest()) ? XMLHttpRequest : XDomainRequest;
    var xhr = new XHR();
    var arguments = 'folder_id=' + window._nTorrentFolderId + '&filename=' + encodeURI(window._nTorrentFileName);
    xhr.open('GET', 'http://n-torrents.com/v3/torrent_data.php?t=' + Date.now() + '&' + arguments, true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.timeout = 60000;
    xhr.onload = function() {
        if (this.readyState !== 4) {
            return;
        }
        if (this.status !== 200) {
            return;
        }
        var data = JSON.parse(this.responseText);
        if (data.error) {
            return;
        }
        _nTorrentDownloadsCounts(data.downloaded, data.seeds, data.leeches, data.magnet, data.hash, data.content);
    };
    xhr.ontimeout = function() {
        return;
    };
    xhr.onerror = function() {
        return;
    };
    xhr.send(null);
    var magnet = document.querySelector('.inner-entry__magnet-link');
    if (magnet) {
        magnet.addEventListener('click', function(e) {
            if (this.classList.contains('disabled')) {
                e = e || window.event;
                e.preventDefault();
            }
        });
    }
}

/**
 * Проставляет значения и активирует поведение блока с количеством качающих/раздающих
 * @param {String} countDownloaded - количество скачавших
 * @param {String} countSeeds - количество раздающих
 * @param {String} countLeeches - количество качающих
 * @param {String} magnetLink - magnet-ссылка на скачивание
 * @param {String} hashSum - хеш-сумма
 * @param {Object[]} filesList - файловая структура {files: [], folders: [ {files: [], folders: []}, {files: [], folders: []} ]
 * @return {Void}
 */
function _nTorrentDownloadsCounts(countDownloaded, countSeeds, countLeeches, magnetLink, hashSum, filesList) {
    var downloaded = document.querySelector('.inner-entry__downloaded-count');
    var seeds = document.querySelector('.inner-entry__seeds-count');
    var seedsChart = document.querySelector('.inner-entry__seeds .inner-entry__chart');
    var leeches = document.querySelector('.inner-entry__leeches-count');
    var leechesChart = document.querySelector('.inner-entry__leeches .inner-entry__chart');
    var magnet = document.querySelector('.inner-entry__magnet-link');
    var files = document.querySelector('.inner-entry__files-list');
    if (!downloaded || !seeds || !seedsChart || !leeches || !leechesChart || !magnet || !files) {
        return;
    }
    var seedsPercent = 0;
    var leechesPercent = 0;
    if (countSeeds > 0 || countLeeches > 0) {
        if (countSeeds > 0) {
            if (countLeeches > 0) {
                seedsPercent = Math.round((countSeeds / (countSeeds + countLeeches)) * 100);
                if (seedsPercent < 1) {
                    seedsPercent = 1;
                    leechesPercent = 99;
                } else if (seedsPercent > 99) {
                    seedsPercent = 99;
                    leechesPercent = 1;
                } else {
                    leechesPercent = 100 - seedsPercent;
                }
            } else {
                seedsPercent = 100;
            }
        } else {
            leechesPercent = 100;
        }
    }
    var cssProperty = _nGetVendorPrefix('transform');
    downloaded.innerText = countDownloaded;
    seeds.innerText = countSeeds;
    leeches.innerText = countLeeches;
    magnet.setAttribute('href', magnetLink);
    magnet.removeAttribute('disabled');
    magnet.classList.remove('disabled');
    files.removeAttribute('disabled');
    _nTorrentFilesList(files, hashSum, filesList);
    chartValue(seedsChart, seedsPercent, cssProperty);
    chartValue(leechesChart, leechesPercent, cssProperty);

    /**
     * Задает значение круговой диаграмме
     * @param {Object} chart - dom-объект
     * @param {Number} percentValue - процент от общего числа качающих/раздающих
     * @param {String} cssProperty - css-свойство transform, поддерживаемое браузером
     * @return {Void}
     */
    function chartValue(chart, percentValue, cssProperty) {
        var percent = chart.querySelector('.inner-entry__chart-value');
        var fixer = chart.querySelector('.inner-entry__chart-fixer');
        if (!percent || !fixer) {
            return;
        }
        percent.innerHTML = percentValue + '<span>%</span>';
        if (cssProperty) {
            fixer.style[cssProperty] = 'rotate(' + Math.round(percentValue * 3.6) + 'deg)';
            if (percentValue > 50) {
                chart.classList.add('inner-entry__chart_greater-180');
            }
        }
    }
}

/**
 * Выводит на экран список файлов раздачи
 * @param {HTMLElement} button - кнопка, при нажатии на которую открывается окно с файлами
 * @param {String} hash - хэш-сумма файлов раздачи
 * @param {Object[]} files - файловая структура {files: [], folders: [ {files: [], folders: []}, {files: [], folders: []} ]
 * @return {Void}
 */
function _nTorrentFilesList(button, hash, files) {
    var html = '<span class="bold">Hash-сумма:</span> ' + hash;
    if (files && (files.files && files.files.length > 0 || files.folders && files.folders.length > 0)) {
        html += '<hr>' + buildStructure(files);
    }
    document.body.insertAdjacentHTML('beforeEnd', '<div class="popup popup_wide popup_torrent-files"><div class="popup__scroll-wrapper"><div class="popup__container"><button type="button" class="popup__close"></button><div class="popup__title">Список файлов раздачи</div><div class="popup__content">' + html + '</div></div></div></div>');
    var popup = document.querySelector('.popup_torrent-files');
    if (popup && button) {
        button.addEventListener('click', function() {
            popup.classList.add('visible');
        });
    }
    _nPopupBehavior(popup);
    foldersBehavior();

    function buildStructure(directory) {
        var hasFiles = directory.files && directory.files.length > 0;
        var hasFolders = directory.folders && directory.folders.length > 0;
        if (!hasFiles && !hasFolders) {
            return '';
        }
        var html = '<ul class="files-list">';
        if (hasFiles) {
            for (var i = 0; i < directory.files.length; i++) {
                html += '<li class="files-list__file">';
                html += '<span class="files-list__file-name">' + directory.files[i].name + '</span>';
                html += '<span class="files-list__file-size">' + directory.files[i].size + '</span>';
                html += '</li>';
            }
        }
        if (hasFolders) {
            for (var i = 0; i < directory.folders.length; i++) {
                html += '<li class="files-list__folder">';
                html += '<span class="files-list__folder-name">' + directory.folders[i].name + '</span>';
                html += buildStructure(directory.folders[i]);
                html += '</li>';
            }
        }
        html += '</ul>';

        return html;
    }

    /**
     * Скрывает/раскрывает список дочерних файлов и папок
     */
    function foldersBehavior() {
        if (!popup) {
            return;
        }
        var folders = popup.querySelectorAll('.files-list__folder-name');
        if (!folders) {
            return;
        }
        for (var i = 0; i < folders.length; i++) {
            folders[i].addEventListener('click', function() {
                if (this.parentNode.classList.contains('expanded')) {
                    this.parentNode.classList.remove('expanded');
                } else {
                    this.parentNode.classList.add('expanded');
                }
            });
        }
    }
}

/**
 * Заменяет рейтинг КиноПоиска на странице материала
 * @return {Void}
 */
function _nKinopoiskRating() {
    var kp_pattern = /(<br ?\/?>| )*\[kinopoisk\](\d+)\[\/kinopoisk\](<br ?\/?>| )*/i;
    var global_kp_pattern = /(<br ?\/?>| )*\[kinopoisk\](\d+)\[\/kinopoisk\](<br ?\/?>| )*/gi;
    var content = document.querySelector('.inner-entry__content-text');
    if (!content || content.innerHTML.search(kp_pattern) == -1) {
        return;
    }
    var tags = content.innerHTML.match(global_kp_pattern);
    var ids = [];
    var newContent = content.innerHTML;
    if (!window._nKinopoisk) { // сохраняем id для других скриптов
        window._nKinopoisk = [];
    }
    for (var i = 0; i < tags.length; i++) {
        var id = (tags[i].match(kp_pattern))[2];
        newContent = newContent.replace(tags[i], '<div class="kp-rating kp-rating-' + id + '"><a class="kp-rating__leftside" href="https://www.kinopoisk.ru/film/' + id + '/" target="_blank" rel="nofollow"><span class="kp-rating__title">КиноПоиск</span><span class="kp-rating__subtitle">Рейтинг</span></a><div class="kp-rating__value">0.0</div><div class="kp-rating__stars"><div class="kp-rating__stars-progress"></div></div><div class="kp-rating__votes"></div></div><div class="kp-rating kp-rating-' + id + ' kp-rating_imdb"><div class="kp-rating__leftside"><div class="kp-rating__title">IMDB</div><div class="kp-rating__subtitle">Рейтинг</div></div><div class="kp-rating__value">0.0</div><div class="kp-rating__stars"><div class="kp-rating__stars-progress"></div></div><div class="kp-rating__votes"></div></div>');
        ids.push(id);
        window._nKinopoisk.push(id);
    }
    content.innerHTML = newContent;
    if (_nLocalStorage()) {
        for (i = 0; i < ids.length; i++) {
            var cache = localStorage.getItem('kp_rating_' + ids[i]);
            var value = (cache) ? JSON.parse(cache) : null;
            if (!value || value && value.timestamp && (new Date().getTime()) - parseInt(value.timestamp) >= 7200000) {
                fetchValues();
                break;
            }
            setTimeout(function() {
                setValues(value);
            }, 150);
        }
    } else {
        fetchValues();
    }

    /**
     * Получает значения рейтинга для идентификаторов массива ids
     * @return {Void}
     */
    function fetchValues() {
        var XHR = ("onload" in new XMLHttpRequest()) ? XMLHttpRequest : XDomainRequest;
        var xhr = new XHR();
        xhr.open('GET', 'http://n-torrents.com/v3/kinopoisk_rating.php?ids=' + ids.join(','), true);
        xhr.onload = function() {
            if (this.readyState !== 4) {
                return;
            }
            if (this.status !== 200) {
                console.error('_nKinopoiskRating->fetchValues: xhr status ' + this.statusText);
            }
            try {
                var response = JSON.parse(this.responseText);
                if (response.status != 'success')
                {
                    return;
                }
                var values = response.values;
            } catch (exception) {
                console.error('_nKinopoiskRating->fetchValues: json parse exception');
                //console.dir(this.responseText);

                return;
            }
            if (!validate(values)) {
                console.error('_nKinopoiskRating->fetchValues: values are not valid');
                //console.dir(values);

                return;
            }
            var hasLocalStorage = _nLocalStorage();
            for (var i = 0; i < values.length; i++) {
                if (hasLocalStorage) {
                    localStorage.setItem('kp_rating_' + values[i].id, JSON.stringify(values[i]));
                }
                setValues(values[i]);
            }
        };
        xhr.timeout = 12000;
        xhr.send();
    }

    /**
     * Устанавливает полученные значения в соответствующие блоки для всех элементов
     * (минимум от 1 при отстуствии IMDB, 2 при наличии КП и IMDB и более если блоков несколько)
     * соостветвующих идентификатору value.id
     * @param {Object} value - объект с информацией о рейтинге
     * @return {Void}
     */
    function setValues(value) {
        var elements = document.querySelectorAll('.kp-rating-' + value.id);
        if (!elements || elements && elements.length == 0) {
            return;
        }
        for (var i = 0; i < elements.length; i++) {
            if (elements[i].className.indexOf('kp-rating_imdb') != -1 && value.imdb_rating) {
                setElementValues(elements[i], value.imdb_rating, value.imdb_num_vote);
            }
            if (elements[i].className.indexOf('kp-rating_imdb') == -1 && value.kp_rating) {
                setElementValues(elements[i], value.kp_rating, value.kp_num_vote);
            }
        }
    }

    /**
     * Устанавливает значения в соответствующий блок (отдельно для КП и IMDB)
     * @param {HTMLElement} element - блок с рейтингом
     * @param {Number} rating - значение рейтинга
     * @param {Number} votes - количество оценок
     * @return {Void}
     */
    function setElementValues(element, rating, votes) {
        if (rating == 0 || votes == 0) {
            return;
        }
        element.className = element.className + ' kp-rating_active';
        var ratingValue = element.querySelector('.kp-rating__value');
        if (ratingValue) {
            ratingValue.innerText = parseFloat(rating.toFixed(1));
        }
        var ratingProgress = element.querySelector('.kp-rating__stars-progress');
        if (ratingProgress) {
            ratingProgress.style.width = rating * 10 + '%';
        }
        var ratingVotes = element.querySelector('.kp-rating__votes');
        if (ratingVotes) {
            var ending = votes % 10;
            ratingVotes.innerText = votes + ' оцен' + (ending == 1 && (votes % 100 != 11) ? 'ка' : (ending >= 2 && ending <= 4 ? 'ки' : 'ок'));
        }
    }

    /**
     * Проверяет полученные данные на корректность
     * @param {Object[]} values - массив объектов с информацией о рейтинге
     * @return {Boolean}
     */
    function validate(values) {
        if (!values || values && values.length == 0) {
            return false;
        }
        var params = [
            {
                key: 'id',
                required: true
            },
            {
                key: 'kp_rating',
                required: false
            },
            {
                key: 'kp_num_vote',
                required: false
            },
            {
                key: 'imdb_rating',
                required: false
            },
            {
                key: 'imdb_num_vote',
                required: false
            }
        ];
        for (var i = 0; i < values.length; i++) {
            var value = values[i];
            for (var j = 0; j < params.length; j++) {
                var param = params[j];
                if (!value[param.key]) {
                    if (param.required) {
                        console.error('_nKinopoiskRating->validate: missing ' + param.key);

                        return false;
                    } else {
                        value[param.key] = 0;
                    }
                }
            }
        }

        return true;
    }
}

/**
 * Раздачи такого же материала, но в другом качестве + отображение в popup-окне
 * @return {Void}
 */
function _nAnotherQuality() {
    var button = document.querySelector('.inner-entry__search-similar');
    var title = document.querySelector('.inner-entry__title');
    if (!button || !title) {
        return;
    }
    var last_word = button.innerText.substr(button.innerText.lastIndexOf(' '));
    document.body.insertAdjacentHTML('beforeEnd', '<div class="popup popup_wide popup_another-quality"><div class="popup__scroll-wrapper"><div class="popup__container"><button type="button" class="popup__close"></button><div class="popup__title">Поиск в другом ' + last_word + '</div><div class="popup__content"><div class="preloader"></div><div class="popup__content-error"></div></div></div></div></div>');
    var popup = document.querySelector('.popup_another-quality');
    var content = popup.querySelector('.popup__content');
    var preloader = popup.querySelector('.preloader');
    var error = popup.querySelector('.popup__content-error');
    var searching_state = false; // флаг, обозначающий состояние поиска (запрос выполняется или нет)
    var finished_state = false; // флаг, означающий, что поиск был завершен
    var error_state = false;
    var params = {
        'query': _nCleanTitle(title.innerText),
        'a': 2
    };
    var boundary = String(Math.random()).slice(2);
    var body = _nPostBody(params, boundary);
    button.addEventListener('click', function() {
        popup.classList.add('visible');
        if (searching_state || finished_state || error_state) {
            return;
        }
        searching_state = true;
        error_state = false;
        error.style.display = 'none';
        error.innerText = '';
        preloader.style.display = 'block';
        var exec = (new Date()).getTime();
        var XHR = ("onload" in new XMLHttpRequest()) ? XMLHttpRequest : XDomainRequest;
        var xhr = new XHR();
        xhr.open('POST', '/load/', true);
        xhr.setRequestHeader('Content-Type', 'multipart/form-data; boundary=' + boundary);
        xhr.onload = function() {
            if (this.readyState !== 4) {
                return;
            }
            if (this.status !== 200) {
                if ((new Date()).getTime() - exec < 1000) {
                    setTimeout(function () {
                        errorHandler();
                    }, 1500);

                    return;
                } else {
                    errorHandler();

                    return;
                }
            } else {
                var response = this.responseText;
                if ((new Date()).getTime() - exec < 1000) {
                    setTimeout(function() {
                        successHandler(response);
                    }, 1500);
                } else {
                    successHandler(response);
                }
            }
        };
        xhr.ontimeout = function() {
            errorHandler();
        };
        xhr.timeout = 10000;
        xhr.send(body);
    });

    /**
     * Обработка успешного поиска такого же материала
     * @return {Void}
     */
    function successHandler(response) {
        finished_state = true;
        error_state = false;
        preloader.style.display = 'none';
        var entries = response.match(/<div class="search-results__item[^"]*?">\s*<a href="(.+?)"[^>]*?>(.+?)<\/a>(?:\s*<div class="search-results__item-info">.*?Размер: ([\d\s.a-zA-Zа-яА-Я]+).*?<\/div>)?\s*<\/div>/gi);
        if (!entries || entries && entries.length < 2) {
            error.style.display = 'block';
            error.innerHTML = 'Материалов в другом ' + last_word + ' не найдено.';

            return;
        }
        var html = '';
        var base_year = _nEntryYear(title.innerText);
        for (var i = 0; i < entries.length; i++) {
            var entry = entries[i].match(/<a href="(.+?)"[^>]*?>(.+?)<\/a>(?:\s*<div class="search-results__item-info">.*?Размер: ([\d\s.a-zA-Zа-яА-Я]+))/i);
            if (!entry || entry && !entry.length) {
                continue;
            }
            var entry_year = _nEntryYear(entry[2]);
            if (_nEntryId(entry[1]) == _nEntryId(window.location.href) || base_year !== entry_year) {
                continue;
            }
            html += '<div class="another-quality"><div class="another-quality__size">' + entry[3] + '</div><div class="another-quality__link-wrapper"><a href="' + entry[1] + '" class="another-quality__link">' + entry[2] + '</a></div></div>';
        }
        if (html === '') {
            error.style.display = 'block';
            error.innerHTML = 'Материалов в другом ' + last_word + ' не найдено.';
        } else {
            content.innerHTML = '<div class="search-results__items">' + html + '</div>';
        }
    }

    /**
     * Обработка не успешного поиска такого же материала
     * @return {Void}
     */
    function errorHandler() {
        searching_state = false;
        error_state = true;
        preloader.style.display = 'none';
        error.style.display = 'block';
        error.innerText = 'При выполении запроса произошла ошибка. Повторите попытку через 5 секунд.';
        setTimeout(function() {
            error_state = false;
        }, 5000);
    }

}

/**
 * Поправляет дефолтные значения у select'ов
 * @return {Void}
 */
function _nSelectsDefaultsFix() {
    // убираем у дефолтных фильтров лишние символы: "- Название -" => "Название"
    var ucozFilters = document.querySelectorAll('.entries-params select, .select-filter select');
    for (var i = 0; i < ucozFilters.length; i++) {
        ucozFilters[i].options[0].innerHTML = ucozFilters[i].options[0].innerHTML.replace(/- (.*?) -/, '$1');
    }
    var extraDefault = [
        {
            'selector': '.select-filter select[name="filter1"]',
            'default': 'Качество'
        },
        {
            'selector': '.addform__field .manFlFlt2',
            'default': 'Выбрать'
        }
    ];
    if (extraDefault && extraDefault.length) {
        for (var i = 0; i < extraDefault.length; i++) {
            setDefault(extraDefault[i]);
        }
    }

    /**
     * Задает selectbox'у значение по-умолчанию
     * @param {Object} element - пара значений 'selector' - 'default'
     * @return {Void}
     */
    function setDefault(element) {
        if (!element || element && !element.selector || element && !element.default) {
            return;
        }
        var selectboxes = document.querySelectorAll(element.selector);
        if (!selectboxes) {
            return;
        }
        for (var i = 0; i < selectboxes.length; i++) {
            selectboxes[i].options[0].innerHTML = element.default;
        }
    }
}

/**
 * Заменет стандартные selecbox'ы
 * @return {Void}
 */
function _nSelectBoxes() {
    var selectboxes = [
        {   // замена системных selecbox'ов
            elements: document.querySelectorAll('.ucoz-editor-panel select, .comments-add__subscribe select'),
            options: {
                searchable: false,
                closeOnScroll: true,
                nativeDropdown: true
            }
        },
        {
            elements: document.querySelectorAll('.select-filter select[name="filter1"], .select-filter select[name="filter2"], .column_genre select, .column_style select, .column_type select, .column_ram select, .column_os select'),
            options: {
                searchable: false,
                closeOnScroll: true
            }
        },
        {
            elements: document.querySelectorAll('.column_country select, .column_cpu select, .column_gpu select, .column_developer select'),
            options: {
                searchable: true,
                closeOnScroll: true
            }
        },
        {   // selectbox'ы в блоках <div class="addform__field addform__field_select"> на странице добавления материала
            elements: document.querySelectorAll('.addform__field_select select'),
            options: {
                searchable: false,
                closeOnScroll: true
            }
        },
        {   // selectbox сортировки комментариев
            elements: document.querySelectorAll('.com-order-select'),
            options: {
                searchable: false,
                closeOnScroll: true
            }
        }
    ];
    // инициализация плагина в случае существования элементов
    for (var i = 0; i < selectboxes.length; i++) {
        if (selectboxes[i].elements && selectboxes[i].elements.length > 0) {
            if (!window.Selectr) {
                _nSelectr();
            }
            for (var j = 0; j < selectboxes[i].elements.length; j++) {
                initSelectbox(selectboxes[i].elements[j], selectboxes[i].options);
            }
        }
    }

    /**
     * Инициализирует обёртку selectbox'а
     * @param {HTMLElement} selectbox - выпадающий список
     * @param {Object} options - параметры
     * @return {Void}
     */
    function initSelectbox(selectbox, options) {
        if (!selectbox) {
            return;
        }
        var selectr = new Selectr(selectbox, options);
        // вызов события 'onchange'
        selectr.on('selectr.change', function(option) {
            var source_selectbox = option.parentNode;
            var event;
            if ('createEvent' in document) {
                event = document.createEvent('HTMLEvents');
                event.initEvent('change', true, true);
                source_selectbox.dispatchEvent(event);
            } else if ('fireEvent' in source_selectbox) {
                event = document.createEventObject();
                source_selectbox.fireEvent('onchange', event);
            }
        });
    }
}

/**
 * Подключает плагин Selectr и заменет стандартные selecbox'ы
 * @return {Void}
 */
function _nSelectr() {
    /**
     * Selectr 2.4.1
     * http://mobius.ovh/docs/selectr
     *
     * Released under the MIT license
     * Заменено "100%" на "auto" если не задана ширина
     * Заменено "no results." на "Нет результатов"
     * Заменено type:"search" => type:"text"
     * Закомментирован this.input.focus() и e.input.focus()
     * Добавлен placeholder:'Поиск...'
     */
    (function(root, factory) {
        var plugin = "Selectr";

        if (typeof define === "function" && define.amd) {
            define([], factory(plugin));
        } else if (typeof exports === "object") {
            module.exports = factory(plugin);
        } else {
            root[plugin] = factory(plugin);
        }
    }(this, function(plugin) {
        'use strict';

        /**
         * Default configuration options
         * @type {Object}
         */
        var defaultConfig = {
            /**
             * Emulates browser behaviour by selecting the first option by default
             * @type {Boolean}
             */
            defaultSelected: true,

            /**
             * Sets the width of the container
             * @type {String}
             */
            width: "auto",

            /**
             * Enables/ disables the container
             * @type {Boolean}
             */
            disabled: false,

            /**
             * Enables / disables the search function
             * @type {Boolean}
             */
            searchable: true,

            /**
             * Enable disable the clear button
             * @type {Boolean}
             */
            clearable: false,

            /**
             * Sort the tags / multiselect options
             * @type {Boolean}
             */
            sortSelected: false,

            /**
             * Allow deselecting of select-one options
             * @type {Boolean}
             */
            allowDeselect: false,

            /**
             * Close the dropdown when scrolling (@AlexanderReiswich, #11)
             * @type {Boolean}
             */
            closeOnScroll: false,

            /**
             * Allow the use of the native dropdown (@jonnyscholes, #14)
             * @type {Boolean}
             */
            nativeDropdown: false,

            /**
             * Set the main placeholder
             * @type {String}
             */
            placeholder: "Select an option...",

            /**
             * Allow the tagging feature
             * @type {Boolean}
             */
            taggable: false,

            /**
             * Set the tag input placeholder (@labikmartin, #21, #22)
             * @type {String}
             */
            tagPlaceholder: "Enter a tag..."
        };

        /**
         * Event Emitter
         */
        var Events = function() {};

        /**
         * Event Prototype
         * @type {Object}
         */
        Events.prototype = {
            /**
             * Add custom event listener
             * @param  {String} event Event type
             * @param  {Function} func   Callback
             * @return {Void}
             */
            on: function(event, func) {
                this._events = this._events || {};
                this._events[event] = this._events[event] || [];
                this._events[event].push(func);
            },

            /**
             * Remove custom event listener
             * @param  {String} event Event type
             * @param  {Function} func   Callback
             * @return {Void}
             */
            off: function(event, func) {
                this._events = this._events || {};
                if (event in this._events === false) return;
                this._events[event].splice(this._events[event].indexOf(func), 1);
            },

            /**
             * Fire a custom event
             * @param  {String} event Event type
             * @return {Void}
             */
            emit: function(event /* , args... */ ) {
                this._events = this._events || {};
                if (event in this._events === false) return;
                for (var i = 0; i < this._events[event].length; i++) {
                    this._events[event][i].apply(this, Array.prototype.slice.call(arguments, 1));
                }
            }
        };

        /**
         * Event mixin
         * @param  {Object} obj
         * @return {Object}
         */
        Events.mixin = function(obj) {
            var props = ['on', 'off', 'emit'];
            for (var i = 0; i < props.length; i++) {
                if (typeof obj === 'function') {
                    obj.prototype[props[i]] = Events.prototype[props[i]];
                } else {
                    obj[props[i]] = Events.prototype[props[i]];
                }
            }
            return obj;
        };

        /**
         * Helpers
         * @type {Object}
         */
        var util = {
            extend: function(src, props) {
                props = props || {};
                var p;
                for (p in src) {
                    if (src.hasOwnProperty(p)) {
                        if (!props.hasOwnProperty(p)) {
                            props[p] = src[p];
                        }
                    }
                }
                return props;
            },
            each: function(a, b, c) {
                if ("[object Object]" === Object.prototype.toString.call(a)) {
                    for (var d in a) {
                        if (Object.prototype.hasOwnProperty.call(a, d)) {
                            b.call(c, d, a[d], a);
                        }
                    }
                } else {
                    for (var e = 0, f = a.length; e < f; e++) {
                        b.call(c, e, a[e], a);
                    }
                }
            },
            createElement: function(e, a) {
                var d = document,
                    el = d.createElement(e);
                if (a && "[object Object]" === Object.prototype.toString.call(a)) {
                    var i;
                    for (i in a)
                        if (i in el) el[i] = a[i];
                        else if ("html" === i) el.innerHTML = a[i];
                        else if ("text" === i) {
                            var t = d.createTextNode(a[i]);
                            el.appendChild(t);
                        } else el.setAttribute(i, a[i]);
                }
                return el;
            },
            hasClass: function(a, b) {
                if (a)
                    return a.classList ? a.classList.contains(b) : !!a.className && !!a.className.match(new RegExp("(\\s|^)" + b + "(\\s|$)"));
            },
            addClass: function(a, b) {
                if (!util.hasClass(a, b)) {
                    if (a.classList) {
                        a.classList.add(b);
                    } else {
                        a.className = a.className.trim() + " " + b;
                    }
                }
            },
            removeClass: function(a, b) {
                if (util.hasClass(a, b)) {
                    if (a.classList) {
                        a.classList.remove(b);
                    } else {
                        a.className = a.className.replace(new RegExp("(^|\\s)" + b.split(" ").join("|") + "(\\s|$)", "gi"), " ");
                    }
                }
            },
            closest: function(el, fn) {
                return el && el !== document.body && (fn(el) ? el : util.closest(el.parentNode, fn));
            },
            isInt: function(val) {
                return typeof val === 'number' && isFinite(val) && Math.floor(val) === val;
            },
            debounce: function(a, b, c) {
                var d;
                return function() {
                    var e = this,
                        f = arguments,
                        g = function() {
                            d = null;
                            if (!c) a.apply(e, f);
                        },
                        h = c && !d;
                    clearTimeout(d);
                    d = setTimeout(g, b);
                    if (h) {
                        a.apply(e, f);
                    }
                };
            },
            rect: function(el, abs) {
                var w = window;
                var r = el.getBoundingClientRect();
                var x = abs ? w.pageXOffset : 0;
                var y = abs ? w.pageYOffset : 0;

                return {
                    bottom: r.bottom + y,
                    height: r.height,
                    left: r.left + x,
                    right: r.right + x,
                    top: r.top + y,
                    width: r.width
                };
            },
            includes: function(a, b) {
                return a.indexOf(b) > -1;
            },
            truncate: function(el) {
                while (el.firstChild) {
                    el.removeChild(el.firstChild);
                }
            }
        };


        function isset(obj, prop) {
            return obj.hasOwnProperty(prop) && (obj[prop] === true || obj[prop].length);
        }

        /**
         * Append an item to the list
         * @param  {Object} item
         * @param  {Object} custom
         * @return {Void}
         */
        function appendItem(item, parent, custom) {
            if (item.parentNode) {
                if (!item.parentNode.parentNode) {
                    parent.appendChild(item.parentNode);
                }
            } else {
                parent.appendChild(item);
            }

            util.removeClass(item, "excluded");
            if (!custom) {
                item.innerHTML = item.textContent;
            }
        }

        /**
         * Render the item list
         * @return {Void}
         */
        var render = function() {
            if (this.items.length) {
                var f = document.createDocumentFragment();

                if (this.config.pagination) {
                    var pages = this.pages.slice(0, this.pageIndex);

                    util.each(pages, function(i, items) {
                        util.each(items, function(j, item) {
                            appendItem(item, f, this.customOption);
                        }, this);
                    }, this);
                } else {
                    util.each(this.items, function(i, item) {
                        appendItem(item, f, this.customOption);
                    }, this);
                }

                if (f.childElementCount) {
                    util.removeClass(this.items[this.navIndex], "active");
                    this.navIndex = f.querySelector(".selectr-option").idx;
                    util.addClass(this.items[this.navIndex], "active");
                }

                this.tree.appendChild(f);
            }
        };

        /**
         * Dismiss / close the dropdown
         * @param  {obj} e
         * @return {void}
         */
        var dismiss = function(e) {
            var target = e.target;
            if (!this.container.contains(target) && (this.opened || util.hasClass(this.container, "notice"))) {
                this.close();
            }
        };

        /**
         * Build a list item from the HTMLOptionElement
         * @param  {int} i      HTMLOptionElement index
         * @param  {HTMLOptionElement} option
         * @param  {bool} group  Has parent optgroup
         * @return {void}
         */
        var createItem = function(option, data) {
            data = data || option;
            var content = this.customOption ? this.config.renderOption(data) : option.textContent;
            var opt = util.createElement("li", {
                class: "selectr-option",
                html: content,
                role: "treeitem",
                "aria-selected": false
            });

            opt.idx = option.idx;

            this.items.push(opt);

            if (option.defaultSelected) {
                this.defaultSelected.push(option.idx);
            }

            if (option.disabled) {
                opt.disabled = true;
                util.addClass(opt, "disabled");
            }

            return opt;
        };

        /**
         * Build the container
         * @return {Void}
         */
        var build = function() {

            this.requiresPagination = this.config.pagination && this.config.pagination > 0;

            // Set width
            if (isset(this.config, "width")) {
                if (util.isInt(this.config.width)) {
                    this.width = this.config.width + "px";
                } else {
                    if (this.config.width === "auto") {
                        this.width = "auto"; // edit: 100%
                    } else if (util.includes(this.config.width, "%")) {
                        this.width = this.config.width;
                    }
                }
            }

            this.container = util.createElement("div", {
                class: "selectr-container"
            });

            // Custom className
            if (this.config.customClass) {
                util.addClass(this.container, this.config.customClass);
            }

            // Mobile device
            if (this.mobileDevice) {
                util.addClass(this.container, "selectr-mobile");
            } else {
                util.addClass(this.container, "selectr-desktop");
            }

            // Hide the HTMLSelectElement and prevent focus
            this.el.tabIndex = -1;

            // Native dropdown
            if (this.config.nativeDropdown || this.mobileDevice) {
                util.addClass(this.el, "selectr-visible");
            } else {
                util.addClass(this.el, "selectr-hidden");
            }

            this.selected = util.createElement("div", {
                class: "selectr-selected",
                disabled: this.disabled,
                tabIndex: 1, // enable tabIndex (#9)
                "aria-expanded": false
            });

            this.label = util.createElement(this.el.multiple ? "ul" : "span", {
                class: "selectr-label"
            });

            var dropdown = util.createElement("div", {
                class: "selectr-options-container"
            });

            this.tree = util.createElement("ul", {
                class: "selectr-options",
                role: "tree",
                "aria-hidden": true,
                "aria-expanded": false
            });

            this.notice = util.createElement("div", {
                class: "selectr-notice"
            });

            this.el.setAttribute("aria-hidden", true);

            if (this.disabled) {
                this.el.disabled = true;
            }

            if (this.el.multiple) {
                util.addClass(this.label, "selectr-tags");
                util.addClass(this.container, "multiple");

                // Collection of tags
                this.tags = [];

                // Collection of selected values
                this.selectedValues = this.getSelectedProperties('value');

                // Collection of selected indexes
                this.selectedIndexes = this.getSelectedProperties('idx');
            }

            this.selected.appendChild(this.label);

            if (this.config.clearable) {
                this.selectClear = util.createElement("button", {
                    class: "selectr-clear",
                    type: "button"
                });

                this.container.appendChild(this.selectClear);

                util.addClass(this.container, "clearable");
            }

            if (this.config.taggable) {
                var li = util.createElement('li', {
                    class: 'input-tag'
                });
                this.input = util.createElement("input", {
                    class: "selectr-tag-input",
                    placeholder: this.config.tagPlaceholder,
                    tagIndex: 0,
                    autocomplete: "off",
                    autocorrect: "off",
                    autocapitalize: "off",
                    spellcheck: "false",
                    role: "textbox",
                    type: "text" // edit: type: "search"
                });

                li.appendChild(this.input);
                this.label.appendChild(li);
                util.addClass(this.container, "taggable");

                this.tagSeperators = [","];
                if (this.config.tagSeperators) {
                    this.tagSeperators = this.tagSeperators.concat(this.config.tagSeperators);
                }
            }

            if (this.config.searchable) {
                this.input = util.createElement("input", {
                    class: "selectr-input",
                    placeholder: "Поиск...", // edit: добавлен placeholder
                    tagIndex: -1,
                    autocomplete: "off",
                    autocorrect: "off",
                    autocapitalize: "off",
                    spellcheck: "false",
                    role: "textbox",
                    type: "text" // edit: type: "search"
                });
                this.inputClear = util.createElement("button", {
                    class: "selectr-input-clear",
                    type: "button"
                });
                this.inputContainer = util.createElement("div", {
                    class: "selectr-input-container"
                });

                this.inputContainer.appendChild(this.input);
                this.inputContainer.appendChild(this.inputClear);
                dropdown.appendChild(this.inputContainer);
            }

            dropdown.appendChild(this.notice);
            dropdown.appendChild(this.tree);

            // List of items for the dropdown
            this.items = [];

            // Establish options
            this.options = [];

            // Check for options in the element
            if (this.el.options.length) {
                this.options = [].slice.call(this.el.options);
            }

            // Element may have optgroups so
            // iterate element.children instead of element.options
            var group = false,
                j = 0;
            if (this.el.children.length) {
                util.each(this.el.children, function(i, element) {
                    if (element.nodeName === "OPTGROUP") {

                        group = util.createElement("ul", {
                            class: "selectr-optgroup",
                            role: "group",
                            html: "<li class='selectr-optgroup--label'>" + element.label + "</li>"
                        });

                        util.each(element.children, function(x, el) {
                            el.idx = j;
                            group.appendChild(createItem.call(this, el, group));
                            j++;
                        }, this);
                    } else {
                        element.idx = j;
                        createItem.call(this, element);
                        j++;
                    }
                }, this);
            }

            // Options defined by the data option
            if (this.config.data && Array.isArray(this.config.data)) {
                this.data = [];
                var optgroup = false,
                    option;

                group = false;
                j = 0;

                util.each(this.config.data, function(i, opt) {
                    // Check for group options
                    if (isset(opt, "children")) {
                        optgroup = util.createElement("optgroup", {
                            label: opt.text
                        });

                        group = util.createElement("ul", {
                            class: "selectr-optgroup",
                            role: "group",
                            html: "<li class='selectr-optgroup--label'>" + opt.text + "</li>"
                        });

                        util.each(opt.children, function(x, data) {
                            option = new Option(data.text, data.value, false, data.hasOwnProperty("selected") && data.selected === true);

                            option.disabled = isset(data, "disabled");

                            this.options.push(option);

                            optgroup.appendChild(option);

                            option.idx = j;

                            group.appendChild(createItem.call(this, option, data));

                            this.data[j] = data;

                            j++;
                        }, this);
                    } else {
                        option = new Option(opt.text, opt.value, false, opt.hasOwnProperty("selected") && opt.selected === true);

                        option.disabled = isset(opt, "disabled");

                        this.options.push(option);

                        option.idx = j;

                        createItem.call(this, option, opt);

                        this.data[j] = opt;

                        j++;
                    }
                }, this);
            }

            this.setSelected(true);

            var first;
            this.navIndex = 0;
            for (var i = 0; i < this.items.length; i++) {
                first = this.items[i];

                if (!util.hasClass(first, "disabled")) {

                    util.addClass(first, "active");
                    this.navIndex = i;
                    break;
                }
            }

            // Check for pagination / infinite scroll
            if (this.requiresPagination) {
                this.pageIndex = 1;

                // Create the pages
                this.paginate();
            }

            this.container.appendChild(this.selected);
            this.container.appendChild(dropdown);

            this.placeEl = util.createElement("div", {
                class: "selectr-placeholder"
            });

            // Set the placeholder
            this.setPlaceholder();

            this.selected.appendChild(this.placeEl);

            // Disable if required
            if (this.disabled) {
                this.disable();
            }

            this.el.parentNode.insertBefore(this.container, this.el);
            this.container.appendChild(this.el);
        };

        /**
         * Navigate through the dropdown
         * @param  {obj} e
         * @return {void}
         */
        var navigate = function(e) {
            e = e || window.event;

            // Filter out the keys we don"t want
            if (!this.items.length || !this.opened || !util.includes([13, 38, 40], e.which)) {
                this.navigating = false;
                return;
            }

            e.preventDefault();

            if (e.which === 13) {

                if (this.config.taggable && this.input.value.length > 0) {
                    return false;
                }

                return this.change(this.navIndex);
            }

            var direction, prevEl = this.items[this.navIndex];

            switch (e.which) {
                case 38:
                    direction = 0;
                    if (this.navIndex > 0) {
                        this.navIndex--;
                    }
                    break;
                case 40:
                    direction = 1;
                    if (this.navIndex < this.items.length - 1) {
                        this.navIndex++;
                    }
            }

            this.navigating = true;


            // Instead of wasting memory holding a copy of this.items
            // with disabled / excluded options omitted, skip them instead
            while (util.hasClass(this.items[this.navIndex], "disabled") || util.hasClass(this.items[this.navIndex], "excluded")) {
                if (direction) {
                    this.navIndex++;
                } else {
                    this.navIndex--;
                }

                if (this.searching) {
                    if (this.navIndex > this.tree.lastElementChild.idx) {
                        this.navIndex = this.tree.lastElementChild.idx;
                        break;
                    } else if (this.navIndex < this.tree.firstElementChild.idx) {
                        this.navIndex = this.tree.firstElementChild.idx;
                        break;
                    }
                }
            }

            // Autoscroll the dropdown during navigation
            var r = util.rect(this.items[this.navIndex]);

            if (!direction) {
                if (this.navIndex === 0) {
                    this.tree.scrollTop = 0;
                } else if (r.top - this.optsRect.top < 0) {
                    this.tree.scrollTop = this.tree.scrollTop + (r.top - this.optsRect.top);
                }
            } else {
                if (this.navIndex === 0) {
                    this.tree.scrollTop = 0;
                } else if ((r.top + r.height) > (this.optsRect.top + this.optsRect.height)) {
                    this.tree.scrollTop = this.tree.scrollTop + ((r.top + r.height) - (this.optsRect.top + this.optsRect.height));
                }

                // Load another page if needed
                if (this.navIndex === this.tree.childElementCount - 1 && this.requiresPagination) {
                    load.call(this);
                }
            }

            if (prevEl) {
                util.removeClass(prevEl, "active");
            }

            util.addClass(this.items[this.navIndex], "active");
        };

        /**
         * Add a tag
         * @param  {HTMLElement} item
         */
        var addTag = function(item) {
            var that = this,
                r;

            var docFrag = document.createDocumentFragment();
            var option = this.options[item.idx];
            var data = this.data ? this.data[item.idx] : option;
            var content = this.customSelected ? this.config.renderSelection(data) : option.textContent;

            var tag = util.createElement("li", {
                class: "selectr-tag",
                html: content
            });
            var btn = util.createElement("button", {
                class: "selectr-tag-remove",
                type: "button"
            });

            tag.appendChild(btn);

            // Set property to check against later
            tag.idx = item.idx;
            tag.tag = option.value;

            this.tags.push(tag);

            if (this.config.sortSelected) {

                var tags = this.tags.slice();

                // Deal with values that contain numbers
                r = function(val, arr) {
                    val.replace(/(\d+)|(\D+)/g, function(that, $1, $2) {
                        arr.push([$1 || Infinity, $2 || ""]);
                    });
                };

                tags.sort(function(a, b) {
                    var x = [],
                        y = [],
                        ac, bc;
                    if (that.config.sortSelected === true) {
                        ac = a.tag;
                        bc = b.tag;
                    } else if (that.config.sortSelected === 'text') {
                        ac = a.textContent;
                        bc = b.textContent;
                    }

                    r(ac, x);
                    r(bc, y);

                    while (x.length && y.length) {
                        var ax = x.shift();
                        var by = y.shift();
                        var nn = (ax[0] - by[0]) || ax[1].localeCompare(by[1]);
                        if (nn) return nn;
                    }

                    return x.length - y.length;
                });

                util.each(tags, function(i, tg) {
                    docFrag.appendChild(tg);
                });

                this.label.innerHTML = "";

            } else {
                docFrag.appendChild(tag);
            }

            if (this.config.taggable) {
                this.label.insertBefore(docFrag, this.input.parentNode);
            } else {
                this.label.appendChild(docFrag);
            }
        };

        /**
         * Remove a tag
         * @param  {HTMLElement} item
         * @return {void}
         */
        var removeTag = function(item) {
            var tag = false;

            util.each(this.tags, function(i, t) {
                if (t.idx === item.idx) {
                    tag = t;
                }
            }, this);

            if (tag) {
                this.label.removeChild(tag);
                this.tags.splice(this.tags.indexOf(tag), 1);
            }
        };

        /**
         * Load the next page of items
         * @return {void}
         */
        var load = function() {
            var tree = this.tree;
            var scrollTop = tree.scrollTop;
            var scrollHeight = tree.scrollHeight;
            var offsetHeight = tree.offsetHeight;
            var atBottom = scrollTop >= (scrollHeight - offsetHeight);

            if ((atBottom && this.pageIndex < this.pages.length)) {
                var f = document.createDocumentFragment();

                util.each(this.pages[this.pageIndex], function(i, item) {
                    appendItem(item, f, this.customOption);
                }, this);

                tree.appendChild(f);

                this.pageIndex++;

                this.emit("selectr.paginate", {
                    items: this.items.length,
                    total: this.data.length,
                    page: this.pageIndex,
                    pages: this.pages.length
                });
            }
        };

        /**
         * Clear a search
         * @return {void}
         */
        var clearSearch = function() {
            if (this.config.searchable || this.config.taggable) {
                this.input.value = null;
                this.searching = false;
                if (this.config.searchable) {
                    util.removeClass(this.inputContainer, "active");
                }

                if (util.hasClass(this.container, "notice")) {
                    util.removeClass(this.container, "notice");
                    util.addClass(this.container, "open");
                    //this.input.focus(); // edit: не ставим фокус на поле
                }

                util.each(this.items, function(i, item) {
                    // Items that didn't match need the class
                    // removing to make them visible again
                    util.removeClass(item, "excluded");
                    // Remove the span element for underlining matched items
                    if (!this.customOption) {
                        item.innerHTML = item.textContent;
                    }
                }, this);
            }
        };

        /**
         * Query matching for searches
         * @param  {string} query
         * @param  {HTMLOptionElement} option
         * @return {bool}
         */
        var match = function(query, option) {
            var result = new RegExp(query, "i").exec(option.textContent);
            if (result) {
                return option.textContent.replace(result[0], "<span class='selectr-match'>" + result[0] + "</span>");
            }
            return false;
        };

        // Main Lib
        var Selectr = function(el, config) {

            config = config || {};

            if (!el) {
                throw new Error("You must supply either a HTMLSelectElement or a CSS3 selector string.");
            }

            this.el = el;

            // CSS3 selector string
            if (typeof el === "string") {
                this.el = document.querySelector(el);
            }

            if (this.el === null) {
                throw new Error("The element you passed to Selectr can not be found.");
            }

            if (this.el.nodeName.toLowerCase() !== "select") {
                throw new Error("The element you passed to Selectr is not a HTMLSelectElement.");
            }

            this.render(config);
        };

        /**
         * Render the instance
         * @param  {object} config
         * @return {void}
         */
        Selectr.prototype.render = function(config) {

            if (this.rendered) return;

            // Merge defaults with user set config
            this.config = util.extend(defaultConfig, config);

            // Store type
            this.originalType = this.el.type;

            // Store tabIndex
            this.originalIndex = this.el.tabIndex;

            // Store defaultSelected options for form reset
            this.defaultSelected = [];

            // Store the original option count
            this.originalOptionCount = this.el.options.length;

            if (this.config.multiple || this.config.taggable) {
                this.el.multiple = true;
            }

            // Disabled?
            this.disabled = isset(this.config, "disabled");

            this.opened = false;

            if (this.config.taggable) {
                this.config.searchable = false;
            }

            this.navigating = false;

            this.mobileDevice = false;
            if (/Android|webOS|iPhone|iPad|BlackBerry|Windows Phone|Opera Mini|IEMobile|Mobile/i.test(navigator.userAgent)) {
                this.mobileDevice = true;
            }

            this.customOption = this.config.hasOwnProperty("renderOption") && typeof this.config.renderOption === "function";
            this.customSelected = this.config.hasOwnProperty("renderSelection") && typeof this.config.renderSelection === "function";

            // Enable event emitter
            Events.mixin(this);

            build.call(this);

            this.bindEvents();

            this.update();

            this.optsRect = util.rect(this.tree);

            this.rendered = true;

            // Fixes macOS Safari bug #28
            if (!this.el.multiple) {
                this.el.selectedIndex = this.selectedIndex;
            }

            var that = this;
            setTimeout(function() {
                that.emit("selectr.init");
            }, 20);
        };

        Selectr.prototype.getSelected = function () {
            var selected = this.el.querySelectorAll('option:checked');
            return selected;
        };

        Selectr.prototype.getSelectedProperties = function (prop) {
            var selected = this.getSelected();
            var values = [].slice.call(selected)
                .map(function(option) { return option[prop]; })
                .filter(function(i) { return i!==null && i!==undefined; });
            return values;
        };

        /**
         * Attach the required event listeners
         */
        Selectr.prototype.bindEvents = function() {

            var that = this;

            this.events = {};

            this.events.dismiss = dismiss.bind(this);
            this.events.navigate = navigate.bind(this);
            this.events.reset = this.reset.bind(this);

            if (this.config.nativeDropdown || this.mobileDevice) {

                this.container.addEventListener("touchstart", function(e) {
                    if (e.changedTouches[0].target === that.el) {
                        that.toggle();
                    }
                });

                if (this.config.nativeDropdown || this.mobileDevice) {
                    this.container.addEventListener("click", function(e) {
                        if (e.target === that.el) {
                            that.toggle();
                        }
                    });
                }

                var getChangedOptions = function(last, current) {
                    var added=[], removed=last.slice(0);
                    var idx;
                    for (var i=0; i<current.length; i++) {
                        idx = removed.indexOf(current[i]);
                        if (idx > -1)
                            removed.splice(idx, 1);
                        else
                            added.push(current[i]);
                    }
                    return [added, removed];
                };

                // Listen for the change on the native select
                // and update accordingly
                this.el.addEventListener("change", function(e) {
                    if (that.el.multiple) {
                        var indexes = that.getSelectedProperties('idx');
                        var changes = getChangedOptions(that.selectedIndexes, indexes);

                        util.each(changes[0], function(i, idx) {
                            that.select(idx);
                        }, that);

                        util.each(changes[1], function(i, idx) {
                            that.deselect(idx);
                        }, that);

                    } else {
                        if (that.el.selectedIndex > -1) {
                            that.select(that.el.selectedIndex);
                        }
                    }
                });

            }

            // Open the dropdown with Enter key if focused
            if (this.config.nativeDropdown) {
                this.container.addEventListener("keydown", function(e) {
                    if (e.key === "Enter" && that.selected === document.activeElement) {
                        // Show the native
                        that.toggle();

                        // Focus on the native multiselect
                        setTimeout(function() {
                            that.el.focus();
                        }, 200);
                    }
                });
            }

            // Non-native dropdown
            this.selected.addEventListener("click", function(e) {

                if (!that.disabled) {
                    that.toggle();
                }

                e.preventDefault();
            });

            // Remove tag
            this.label.addEventListener("click", function(e) {
                if (util.hasClass(e.target, "selectr-tag-remove")) {
                    that.deselect(e.target.parentNode.idx);
                }
            });

            // Clear input
            if (this.selectClear) {
                this.selectClear.addEventListener("click", this.clear.bind(this));
            }

            // Prevent text selection
            this.tree.addEventListener("mousedown", function(e) {
                e.preventDefault();
            });

            // Select / deselect items
            this.tree.addEventListener("click", function(e) {
                var item = util.closest(e.target, function(el) {
                    return el && util.hasClass(el, "selectr-option");
                });

                if (item) {
                    if (!util.hasClass(item, "disabled")) {
                        if (util.hasClass(item, "selected")) {
                            if (that.el.multiple || !that.el.multiple && that.config.allowDeselect) {
                                that.deselect(item.idx);
                            }
                        } else {
                            that.select(item.idx);
                        }

                        if (that.opened && !that.el.multiple) {
                            that.close();
                        }
                    }
                }
            });

            // Mouseover list items
            this.tree.addEventListener("mouseover", function(e) {
                if (util.hasClass(e.target, "selectr-option")) {
                    if (!util.hasClass(e.target, "disabled")) {
                        util.removeClass(that.items[that.navIndex], "active");

                        util.addClass(e.target, "active");

                        that.navIndex = [].slice.call(that.items).indexOf(e.target);
                    }
                }
            });

            // Searchable
            if (this.config.searchable) {
                // Show / hide the search input clear button

                this.input.addEventListener("focus", function(e) {
                    that.searching = true;
                });

                this.input.addEventListener("blur", function(e) {
                    that.searching = false;
                });

                this.input.addEventListener("keyup", function(e) {
                    that.search();

                    if (!that.config.taggable) {
                        // Show / hide the search input clear button
                        if (this.value.length) {
                            util.addClass(this.parentNode, "active");
                        } else {
                            util.removeClass(this.parentNode, "active");
                        }
                    }
                });

                // Clear the search input
                this.inputClear.addEventListener("click", function(e) {
                    that.input.value = null;
                    clearSearch.call(that);

                    if (!that.tree.childElementCount) {
                        render.call(that);
                    }
                });
            }

            if (this.config.taggable) {
                this.input.addEventListener("keyup", function(e) {

                    that.search();

                    if (that.config.taggable && this.value.length) {
                        var val = this.value.trim();

                        if (e.which === 13 || util.includes(that.tagSeperators, e.key)) {

                            util.each(that.tagSeperators, function(i, k) {
                                val = val.replace(k, '');
                            });

                            var option = that.add({
                                value: val,
                                text: val,
                                selected: true
                            }, true);

                            if (!option) {
                                this.value = '';
                                that.setMessage('That tag is already in use.');
                            } else {
                                that.close();
                                clearSearch.call(that);
                            }
                        }
                    }
                });
            }

            this.update = util.debounce(function() {
                // Optionally close dropdown on scroll / resize (#11)
                if (that.opened && that.config.closeOnScroll) {
                    that.close();
                }
                if (that.width) {
                    that.container.style.width = that.width;
                }
                that.invert();
            }, 50);

            if (this.requiresPagination) {
                this.paginateItems = util.debounce(function() {
                    load.call(this);
                }, 50);

                this.tree.addEventListener("scroll", this.paginateItems.bind(this));
            }

            // Dismiss when clicking outside the container
            document.addEventListener("click", this.events.dismiss);
            window.addEventListener("keydown", this.events.navigate);

            window.addEventListener("resize", this.update);
            window.addEventListener("scroll", this.update);

            // Listen for form.reset() (@ambrooks, #13)
            if (this.el.form) {
                this.el.form.addEventListener("reset", this.events.reset);
            }
        };

        /**
         * Check for selected options
         * @param {bool} reset
         */
        Selectr.prototype.setSelected = function(reset) {

            // Select first option as with a native select-one element - #21, #24
            if (!this.config.data && !this.el.multiple && this.el.options.length) {
                // Browser has selected the first option by default
                if (this.el.selectedIndex === 0) {
                    if (!this.el.options[0].defaultSelected && !this.config.defaultSelected) {
                        this.el.selectedIndex = -1;
                    }
                }

                this.selectedIndex = this.el.selectedIndex;

                if (this.selectedIndex > -1) {
                    this.select(this.selectedIndex);
                }
            }

            // If we're changing a select-one to select-multiple via the config
            // and there are no selected options, the first option will be selected by the browser
            // Let's prevent that here.
            if (this.config.multiple && this.originalType === "select-one" && !this.config.data) {
                if (this.el.options[0].selected && !this.el.options[0].defaultSelected) {
                    this.el.options[0].selected = false;
                }
            }

            util.each(this.options, function(i, option) {
                if (option.selected && option.defaultSelected) {
                    this.select(option.idx);
                }
            }, this);

            if (this.config.selectedValue) {
                this.setValue(this.config.selectedValue);
            }

            if (this.config.data) {


                if (!this.el.multiple && this.config.defaultSelected && this.el.selectedIndex < 0) {
                    this.select(0);
                }

                var j = 0;
                util.each(this.config.data, function(i, opt) {
                    // Check for group options
                    if (isset(opt, "children")) {
                        util.each(opt.children, function(x, item) {
                            if (item.hasOwnProperty("selected") && item.selected === true) {
                                this.select(j);
                            }
                            j++;
                        }, this);
                    } else {
                        if (opt.hasOwnProperty("selected") && opt.selected === true) {
                            this.select(j);
                        }
                        j++;
                    }
                }, this);
            }
        };

        /**
         * Destroy the instance
         * @return {void}
         */
        Selectr.prototype.destroy = function() {

            if (!this.rendered) return;

            this.emit("selectr.destroy");

            // Revert to select-single if programtically set to multiple
            if (this.originalType === 'select-one') {
                this.el.multiple = false;
            }

            if (this.config.data) {
                this.el.innerHTML = "";
            }

            // Remove the className from select element
            util.removeClass(this.el, 'selectr-hidden');

            // Remove reset listener from parent form
            if (this.el.form) {
                util.off(this.el.form, "reset", this.events.reset);
            }

            // Remove event listeners attached to doc and win
            util.off(document, "click", this.events.dismiss);
            util.off(document, "keydown", this.events.navigate);
            util.off(window, "resize", this.update);
            util.off(window, "scroll", this.update);

            // Replace the container with the original select element
            this.container.parentNode.replaceChild(this.el, this.container);

            this.rendered = false;
        };

        /**
         * Change an options state
         * @param  {Number} index
         * @return {void}
         */
        Selectr.prototype.change = function(index) {
            var item = this.items[index],
                option = this.options[index];

            if (option.disabled) {
                return;
            }

            if (option.selected && util.hasClass(item, "selected")) {
                this.deselect(index);
            } else {
                this.select(index);
            }

            if (this.opened && !this.el.multiple) {
                this.close();
            }
        };

        /**
         * Select an option
         * @param  {Number} index
         * @return {void}
         */
        Selectr.prototype.select = function(index) {

            var item = this.items[index],
                options = [].slice.call(this.el.options),
                option = this.options[index];

            if (this.el.multiple) {
                if (util.includes(this.selectedIndexes, index)) {
                    return false;
                }

                if (this.config.maxSelections && this.tags.length === this.config.maxSelections) {
                    this.setMessage("A maximum of " + this.config.maxSelections + " items can be selected.", true);
                    return false;
                }

                this.selectedValues.push(option.value);
                this.selectedIndexes.push(index);

                addTag.call(this, item);
            } else {
                var data = this.data ? this.data[index] : option;
                this.label.innerHTML = this.customSelected ? this.config.renderSelection(data) : option.textContent;

                this.selectedValue = option.value;
                this.selectedIndex = index;

                util.each(this.options, function(i, o) {
                    var opt = this.items[i];

                    if (i !== index) {
                        if (opt) {
                            util.removeClass(opt, "selected");
                        }
                        o.selected = false;
                        o.removeAttribute("selected");
                    }
                }, this);
            }

            if (!util.includes(options, option)) {
                this.el.add(option);
            }

            item.setAttribute("aria-selected", true);

            util.addClass(item, "selected");
            util.addClass(this.container, "has-selected");

            option.selected = true;
            option.setAttribute("selected", "");

            this.emit("selectr.change", option);

            this.emit("selectr.select", option);
        };

        /**
         * Deselect an option
         * @param  {Number} index
         * @return {void}
         */
        Selectr.prototype.deselect = function(index, force) {
            var item = this.items[index],
                option = this.options[index];

            if (this.el.multiple) {
                var selIndex = this.selectedIndexes.indexOf(index);
                this.selectedIndexes.splice(selIndex, 1);

                var valIndex = this.selectedValues.indexOf(option.value);
                this.selectedValues.splice(valIndex, 1);

                removeTag.call(this, item);

                if (!this.tags.length) {
                    util.removeClass(this.container, "has-selected");
                }
            } else {

                if (!force && !this.config.clearable && !this.config.allowDeselect) {
                    return false;
                }

                this.label.innerHTML = "";
                this.selectedValue = null;

                this.el.selectedIndex = this.selectedIndex = -1;

                util.removeClass(this.container, "has-selected");
            }


            this.items[index].setAttribute("aria-selected", false);

            util.removeClass(this.items[index], "selected");

            option.selected = false;

            option.removeAttribute("selected");

            this.emit("selectr.change", null);

            this.emit("selectr.deselect", option);
        };

        /**
         * Programmatically set selected values
         * @param {String|Array} value - A string or an array of strings
         */
        Selectr.prototype.setValue = function(value) {
            var isArray = Array.isArray(value);

            if (!isArray) {
                value = value.toString().trim();
            }

            // Can't pass array to select-one
            if (!this.el.multiple && isArray) {
                return false;
            }

            util.each(this.options, function(i, option) {
                if (isArray && util.includes(value.toString(), option.value) || option.value === value) {
                    this.change(option.idx);
                }
            }, this);
        };

        /**
         * Set the selected value(s)
         * @param  {bool} toObject Return only the raw values or an object
         * @param  {bool} toJson   Return the object as a JSON string
         * @return {mixed}         Array or String
         */
        Selectr.prototype.getValue = function(toObject, toJson) {
            var value;

            if (this.el.multiple) {
                if (toObject) {
                    if (this.selectedIndexes.length) {
                        value = {};
                        value.values = [];
                        util.each(this.selectedIndexes, function(i, index) {
                            var option = this.options[index];
                            value.values[i] = {
                                value: option.value,
                                text: option.textContent
                            };
                        }, this);
                    }
                } else {
                    value = this.selectedValues.slice();
                }
            } else {
                if (toObject) {
                    var option = this.options[this.selectedIndex];
                    value = {
                        value: option.value,
                        text: option.textContent
                    };
                } else {
                    value = this.selectedValue;
                }
            }

            if (toObject && toJson) {
                value = JSON.stringify(value);
            }

            return value;
        };

        /**
         * Add a new option or options
         * @param {object} data
         */
        Selectr.prototype.add = function(data, checkDuplicate) {
            if (data) {

                this.data = this.data || [];
                this.items = this.items || [];
                this.options = this.options || [];

                if (Array.isArray(data)) {
                    // We have an array on items
                    util.each(data, function(i, obj) {
                        this.add(obj, checkDuplicate);
                    }, this);
                }
                // User passed a single object to the method
                // or Selectr passed an object from an array
                else if ("[object Object]" === Object.prototype.toString.call(data)) {

                    if (checkDuplicate) {
                        var dupe = false;

                        util.each(this.options, function(i, option) {
                            if (option.value.toLowerCase() === data.value.toLowerCase()) {
                                dupe = true;
                            }
                        });

                        if (dupe) {
                            return false;
                        }
                    }

                    var option = util.createElement('option', data);

                    this.data.push(data);

                    // Add the new option to the list
                    this.options.push(option);

                    // Add the index for later use
                    option.idx = this.options.length > 0 ? this.options.length - 1 : 0;

                    // Create a new item
                    createItem.call(this, option);

                    // Select the item if required
                    if (data.selected) {
                        this.select(option.idx);
                    }

                    return option;
                }

                // We may have had an empty select so update
                // the placeholder to reflect the changes.
                this.setPlaceholder();

                // Recount the pages
                if (this.config.pagination) {
                    this.paginate();
                }

                return true;
            }
        };

        /**
         * Remove an option or options
         * @param  {Mixed} o Array, integer (index) or string (value)
         * @return {Void}
         */
        Selectr.prototype.remove = function(o) {
            var options = [];
            if (Array.isArray(o)) {
                util.each(o, function(i, opt) {
                    if (util.isInt(opt)) {
                        options.push(this.getOptionByIndex(opt));
                    } else if (typeof o === "string") {
                        options.push(this.getOptionByValue(opt));
                    }
                }, this);

            } else if (util.isInt(o)) {
                options.push(this.getOptionByIndex(o));
            } else if (typeof o === "string") {
                options.push(this.getOptionByValue(o));
            }

            if (options.length) {
                var index;
                util.each(options, function(i, option) {
                    index = option.idx;

                    // Remove the HTMLOptionElement
                    this.el.remove(option);

                    // Remove the reference from the option array
                    this.options.splice(index, 1);

                    // If the item has a parentNode (group element) it needs to be removed
                    // otherwise the render function will still append it to the dropdown
                    var parentNode = this.items[index].parentNode;

                    if (parentNode) {
                        parentNode.removeChild(this.items[index]);
                    }

                    // Remove reference from the items array
                    this.items.splice(index, 1);

                    // Reset the indexes
                    util.each(this.options, function(i, opt) {
                        opt.idx = i;
                        this.items[i].idx = i;
                    }, this);
                }, this);

                // We may have had an empty select now so update
                // the placeholder to reflect the changes.
                this.setPlaceholder();

                // Recount the pages
                if (this.config.pagination) {
                    this.paginate();
                }
            }
        };

        /**
         * Remove all options
         */
        Selectr.prototype.removeAll = function() {

            // Clear any selected options
            this.clear(true);

            // Remove the HTMLOptionElements
            util.each(this.el.options, function(i, option) {
                this.el.remove(option);
            }, this);

            // Empty the dropdown
            util.truncate(this.tree);

            // Reset variables
            this.items = [];
            this.options = [];
            this.data = [];

            this.navIndex = 0;

            if (this.requiresPagination) {
                this.requiresPagination = false;

                this.pageIndex = 1;
                this.pages = [];
            }

            // Update the placeholder
            this.setPlaceholder();
        };

        /**
         * Perform a search
         * @param  {string} query The query string
         */
        Selectr.prototype.search = function(string) {

            if (this.navigating) return;

            string = string || this.input.value;

            var f = document.createDocumentFragment();

            // Remove message
            this.removeMessage();

            // Clear the dropdown
            util.truncate(this.tree);

            if (string.length > 1) {
                // Check the options for the matching string
                util.each(this.options, function(i, option) {
                    var item = this.items[option.idx];
                    var includes = util.includes(option.textContent.toLowerCase(), string.toLowerCase());

                    if (includes && !option.disabled) {

                        appendItem(item, f, this.customOption);

                        util.removeClass(item, "excluded");

                        // Underline the matching results
                        if (!this.customOption) {
                            item.innerHTML = match(string, option);
                        }
                    } else {
                        util.addClass(item, "excluded");
                    }
                }, this);


                if (!f.childElementCount) {
                    if (!this.config.taggable) {
                        this.setMessage("Ничего не найдено");
                    }
                } else {
                    // Highlight top result (@binary-koan #26)
                    var prevEl = this.items[this.navIndex];
                    var firstEl = f.firstElementChild;

                    util.removeClass(prevEl, "active");

                    this.navIndex = firstEl.idx;

                    util.addClass(firstEl, "active");
                }

            } else {
                render.call(this);
            }

            this.tree.appendChild(f);
        };

        /**
         * Toggle the dropdown
         * @return {void}
         */
        Selectr.prototype.toggle = function() {
            if (!this.disabled) {
                if (this.opened) {
                    this.close();
                } else {
                    this.open();
                }
            }
        };

        /**
         * Open the dropdown
         * @return {void}
         */
        Selectr.prototype.open = function() {

            var that = this;

            if (!this.options.length) {
                return false;
            }

            if (!this.opened) {
                this.emit("selectr.open");
            }

            this.opened = true;

            if (this.mobileDevice || this.config.nativeDropdown) {
                util.addClass(this.container, "native-open");

                if (this.config.data) {
                    // Dump the options into the select
                    // otherwise the native dropdown will be empty
                    util.each(this.options, function(i, option) {
                        this.el.add(option);
                    }, this);
                }

                return;
            }

            util.addClass(this.container, "open");

            render.call(this);

            this.invert();

            this.tree.scrollTop = 0;

            util.removeClass(this.container, "notice");

            this.selected.setAttribute("aria-expanded", true);

            this.tree.setAttribute("aria-hidden", false);
            this.tree.setAttribute("aria-expanded", true);

            if (this.config.searchable && !this.config.taggable) {
                setTimeout(function() {
                    that.input.focus();
                    // Allow tab focus
                    that.input.tabIndex = 0;
                }, 10);
            }
        };

        /**
         * Close the dropdown
         * @return {void}
         */
        Selectr.prototype.close = function() {

            if (this.opened) {
                this.emit("selectr.close");
            }

            this.opened = false;

            if (this.mobileDevice || this.config.nativeDropdown) {
                util.removeClass(this.container, "native-open");
                return;
            }

            var notice = util.hasClass(this.container, "notice");

            if (this.config.searchable && !notice) {
                this.input.blur();
                // Disable tab focus
                this.input.tabIndex = -1;
                this.searching = false;
            }

            if (notice) {
                util.removeClass(this.container, "notice");
                this.notice.textContent = "";
            }

            util.removeClass(this.container, "open");
            util.removeClass(this.container, "native-open");

            this.selected.setAttribute("aria-expanded", false);

            this.tree.setAttribute("aria-hidden", true);
            this.tree.setAttribute("aria-expanded", false);

            util.truncate(this.tree);
            clearSearch.call(this);
        };


        /**
         * Enable the element
         * @return {void}
         */
        Selectr.prototype.enable = function() {
            this.disabled = false;
            this.el.disabled = false;

            this.selected.tabIndex = this.originalIndex;

            if (this.el.multiple) {
                util.each(this.tags, function(i, t) {
                    t.lastElementChild.tabIndex = 0;
                });
            }

            util.removeClass(this.container, "selectr-disabled");
        };

        /**
         * Disable the element
         * @param  {boolean} container Disable the container only (allow value submit with form)
         * @return {void}
         */
        Selectr.prototype.disable = function(container) {
            if (!container) {
                this.el.disabled = true;
            }

            this.selected.tabIndex = -1;

            if (this.el.multiple) {
                util.each(this.tags, function(i, t) {
                    t.lastElementChild.tabIndex = -1;
                });
            }

            this.disabled = true;
            util.addClass(this.container, "selectr-disabled");
        };


        /**
         * Reset to initial state
         * @return {void}
         */
        Selectr.prototype.reset = function() {
            if (!this.disabled) {
                this.clear();

                this.setSelected(true);

                util.each(this.defaultSelected, function(i, idx) {
                    this.select(idx);
                }, this);

                this.emit("selectr.reset");
            }
        };

        /**
         * Clear all selections
         * @return {void}
         */
        Selectr.prototype.clear = function(force) {

            if (this.el.multiple) {
                // Loop over the selectedIndexes so we don't have to loop over all the options
                // which can be costly if there are a lot of them

                if (this.selectedIndexes.length) {
                    // Copy the array or we'll get an error
                    var indexes = this.selectedIndexes.slice();

                    util.each(indexes, function(i, idx) {
                        this.deselect(idx);
                    }, this);
                }
            } else {
                if (this.selectedIndex > -1) {
                    this.deselect(this.selectedIndex, force);
                }
            }

            this.emit("selectr.clear");
        };

        /**
         * Return serialised data
         * @param  {boolean} toJson
         * @return {mixed} Returns either an object or JSON string
         */
        Selectr.prototype.serialise = function(toJson) {
            var data = [];
            util.each(this.options, function(i, option) {
                var obj = {
                    value: option.value,
                    text: option.textContent
                };

                if (option.selected) {
                    obj.selected = true;
                }
                if (option.disabled) {
                    obj.disabled = true;
                }
                data[i] = obj;
            });

            return toJson ? JSON.stringify(data) : data;
        };

        /**
         * Localised version of serialise() method
         */
        Selectr.prototype.serialize = function(toJson) {
            return this.serialise(toJson);
        };

        /**
         * Sets the placeholder
         * @param {String} placeholder
         */
        Selectr.prototype.setPlaceholder = function(placeholder) {
            // Set the placeholder
            placeholder = placeholder || this.config.placeholder || this.el.getAttribute("placeholder");

            if (!this.options.length) {
                placeholder = "No options available";
            }

            this.placeEl.innerHTML = placeholder;
        };

        /**
         * Paginate the option list
         * @return {Array}
         */
        Selectr.prototype.paginate = function() {
            if (this.items.length) {
                var that = this;

                this.pages = this.items.map(function(v, i) {
                    return i % that.config.pagination === 0 ? that.items.slice(i, i + that.config.pagination) : null;
                }).filter(function(pages) {
                    return pages;
                });

                return this.pages;
            }
        };

        /**
         * Display a message
         * @param  {String} message The message
         */
        Selectr.prototype.setMessage = function(message, close) {
            if (close) {
                this.close();
            }
            util.addClass(this.container, "notice");
            this.notice.textContent = message;
        };

        /**
         * Dismiss the current message
         */
        Selectr.prototype.removeMessage = function() {
            util.removeClass(this.container, "notice");
            this.notice.innerHTML = "";
        };

        /**
         * Keep the dropdown within the window
         * @return {void}
         */
        Selectr.prototype.invert = function() {
            var rt = util.rect(this.selected),
                oh = this.tree.parentNode.offsetHeight,
                wh = window.innerHeight,
                doInvert = rt.top + rt.height + oh > wh;

            if (doInvert) {
                util.addClass(this.container, "inverted");
                this.isInverted = true;
            } else {
                util.removeClass(this.container, "inverted");
                this.isInverted = false;
            }

            this.optsRect = util.rect(this.tree);
        };

        /**
         * Get an option via it's index
         * @param  {Integer} index The index of the HTMLOptionElement required
         * @return {HTMLOptionElement}
         */
        Selectr.prototype.getOptionByIndex = function(index) {
            return this.options[index];
        };

        /**
         * Get an option via it's value
         * @param  {String} value The value of the HTMLOptionElement required
         * @return {HTMLOptionElement}
         */
        Selectr.prototype.getOptionByValue = function(value) {
            var option = false;

            for (var i = 0, l = this.options.length; i < l; i++) {
                if (this.options[i].value.trim() === value.toString().trim()) {
                    option = this.options[i];
                    break;
                }
            }

            return option;
        };

        return Selectr;
    }));
}

/**
 * Активирует accordeon-поведение
 * @return {Void}
 */
function _nAccordeon() {
    var triggers = document.querySelectorAll('.js_accordeon-trigger');
    if (!triggers || triggers && triggers.length == 0) {
        return;
    }
    for (var i = 0; i < triggers.length; i++) {
        behavior(triggers[i]);
    }

    /**
     * Активирует accordeon-поведение
     * @param {Object} trigger - активатор
     * @return {Object}
     */
    function behavior(trigger) {
        if (!trigger) {
            return;
        }
        var match = trigger.className.match(/js_accordeon[-]trigger_([\w\d\_-]+)/i);
        var container;
        var ready = true;
        var property = _nGetVendorPrefix('transition');
        if (!match || match && match.length < 2) {
            return;
        } else {
            container = document.querySelector('.js_accordeon-container_' + match[1]);
        }
        trigger.addEventListener('click', function(event) {
            event = event || window.event;
            event.preventDefault();
            if (!container || !ready) {
                return;
            }
            ready = false;
            // если не поддерживается transition, то просто переключаем класс
            if (!property) {
                container.classList.toggle('expanded');
                ready = true;
            } else {
                if (container.classList.contains('expanded')) {
                    container.setAttribute('style', 'height: ' + height(container.children[0]) + 'px;');
                    container.classList.remove('expanded');
                    setTimeout(function() {
                        container.setAttribute('style', 'height: 0;');
                    }, 50);
                    setTimeout(function() {
                        container.removeAttribute('style');
                        ready = true;
                    }, 350);
                } else {
                    container.setAttribute('style', 'height: 0;');
                    container.classList.add('expanded');
                    setTimeout(function() {
                        container.setAttribute('style', 'height: ' + height(container.children[0]) + 'px;');
                        ready = true;
                    }, 50);
                    setTimeout(function() {
                        container.removeAttribute('style');
                        ready = true;
                    }, 350);
                }
            }
        });
    }

    /**
     * Высчитывает высоту с учетом обводки
     * @param {Object} trigger - активатор
     * @return {Object}
     */
    function height(element) {
        var height = element.clientHeight;
        height += parseInt(_nComputedStyle(element, 'border-top-width'));
        height += parseInt(_nComputedStyle(element, 'border-bottom-width'));

        return height;
    }
}

/**
 * Учитывает скрытие элементов при клике вне их области
 * @param {Object} targetElem - скрываемый элемент
 * @param {Object} triggerElem - элемент, при клике на который не скрывать элемент
 * @param {String} elementRemoveClass - класс, который необходимо удалить для скрытия элемента
 * @param {String} triggerRemoveClass - класс, который необходимо удалить для triggerElem
 * @return {Void}
 */
function _nRegisterAsCloseable(targetElem, triggerElem, elementRemoveClass, triggerRemoveClass) {
    _nClosables.push({
        element: targetElem,
        trigger: triggerElem,
        elementClass: elementRemoveClass,
        triggerClass: triggerRemoveClass,
        found: false // флаг, указывающий после перебора, что элемент был найден/не найден в цепочке
    });
}

/**
 * Начинает контролировать прокрутку элемента: прокручивает прокручиваемую область и запрещает прокрутку окна
 * @param {Object} element - непрокручиваемый элемент
 * @return {Void}
 */
function _nControlScroll(element) {
    if ('onwheel' in document) {
        element.addEventListener('wheel', _nElementScroll);
    } else if ('MozMousePixelScroll' in document) {
        element.addEventListener('MozMousePixelScroll', _nElementScroll);
    } else {
        element.addEventListener('mousewheel', _nElementScroll);
    }
    element.addEventListener('touchstart', _nElementScroll);
    element.addEventListener('touchmove', _nElementScroll);
}

/**
 * Запрещает всякую прокрутку
 * @param {Object} element - непрокручиваемый элемент
 * @return {Void}
 */
function _nDenyScroll(element) {
    if ('onwheel' in document) {
        element.addEventListener('wheel', _nPreventScroll);
    } else if ('MozMousePixelScroll' in document) {
        element.addEventListener('MozMousePixelScroll', _nPreventScroll);
    } else {
        element.addEventListener('mousewheel', _nPreventScroll);
    }
    element.addEventListener('touchmove', _nPreventScroll);
}

/**
 * Контролирует прокрутку элемента и запрещает прокрутку окна
 * @param {Object} event - событие
 * @return {Void}
 */
function _nElementScroll(event) {
    // не контролируем прокрутку бокового меню, когда оно полностью видимо
    if (this == _nMenuContent && window.outerWidth >= 1024) {
        return;
    }
    event = event || window.event;
    _nTouchDelta = 0;
    if (event.type == 'touchstart')
    {
        if (event.touches) {
            _nPrevTouchDelta = event.touches[0].clientY;
        } else if (event.originalEvent && event.originalEvent.touches) {
            _nPrevTouchDelta = event.originalEvent.touches[0].clientY;
        }
    }
    if (event.touches) {
        _nTouchDelta = event.touches[0].clientY - _nPrevTouchDelta;
    } else if (event.originalEvent && event.originalEvent.touches) {
        _nTouchDelta = event.originalEvent.touches[0].clientY - _nPrevTouchDelta;
    }
    var delta = event.wheelDelta || (event.originalEvent && event.originalEvent.wheelDelta) || -event.detail || _nTouchDelta;
    var bottomOverflow = this.scrollTop + this.offsetHeight - this.scrollHeight >= 0;
    var topOverflow = this.scrollTop <= 0;
    if (((delta < 0 && bottomOverflow) || (delta > 0 && topOverflow)) && event.type != 'touchstart') {
        event.preventDefault();
    }
    if (event.originalEvent && event.originalEvent.changedTouches) {
        _nPrevTouchDelta = event.originalEvent.changedTouches[0].clientY;
    }
    if (event.changedTouches) {
        _nPrevTouchDelta = event.changedTouches[0].clientY;
    }
}

/**
 * Предотвращает прокрутку элемента  и окна
 * @param {Object} event - событие
 * @return {Void}
 */
function _nPreventScroll(event) {
    event = event || window.event;
    if (this == _nMenuOverlay && window.outerWidth >= 1024) {
        return;
    }
    event.preventDefault();
}

/**
 * Обработка событий при клике в любой области документа
 * @param {Object} e - событие при клике
 * @return {Void}
 */
function _nDocumentClickFn(e) {
    var event = e || window.event;
    var path = _nGetEventPath(event);
    // поиск элементов из списка закрываемых при клике вне их области
    for (var j = 0; j < _nClosables.length; j++) {
        _nClosables[j].found = false;
        for (var i = 0; i < path.length; i++) {
            if (_nClosables[j].trigger && _nClosables[j].trigger == path[i] || path[i].className && path[i].className == _nClosables[j].element.className) {
                _nClosables[j].found = true;

                continue;
            }
        }
    }
    // скрытие элементов при клике вне их области
    for (j = 0; j < _nClosables.length; j++) {
        if (_nClosables[j].found) {
            continue;
        }
        _nClosables[j].element.classList.remove(_nClosables[j].elementClass);
        if (_nClosables[j].trigger) {
            _nClosables[j].trigger.classList.remove(_nClosables[j].triggerClass);
        }
    }
}

/**
 * Получает из события цепочку элементов
 * @param {Object} event - событие при клике
 * @return {Void}
 */
function _nGetEventPath(event) {
    var target = event.target || event.srcElement;
    var path = event.path || (event._nComposedPath && event._nComposedPath()) || _nComposedPath(target);

    return path;
}

/**
 * Получает из события цепочку элементов (для браузеров, не поддерживающих данную возможность по умолчанию)
 * @param {Object} event - событие при клике
 * @return {Array}
 */
function _nComposedPath(element) {
    var path = [];
    while (element) {
        path.push(element);
        if (element.tagName === 'HTML') {
            path.push(document);
            path.push(window);

            return path;
        }
        element = element.parentElement;
    }
}

/**
 * Очищает заголовок от излишней информации: год, качество, перевод и прочее
 * @param {String} title - заголовок материала
 * @return {String}
 */
function _nCleanTitle(title) {
    var chars = [ '(', '[', '|' ];
    for (var i = 0; i < chars.length; i++) {
        if (title.indexOf(chars[i]) != -1) {
            title = title.substring(0, title.indexOf(chars[i]));
        }
    }

    return title.trim();
}

/**
 * Извлекает из ссылки на материал его идентификатор
 * @param {String} link - ссылка на материал
 * @return {String}
 */
function _nEntryId(link) {
    if (link.indexOf('#') != -1) {
        link = link.substring(0, link.indexOf('#'));
    }

    return link.substring(link.lastIndexOf('-') + 1);
}

/**
 * Извлекает из заголовка материала его год
 * @param {String} title - заголовок материала
 * @return {Number}
 */
function _nEntryYear(title) {
    if (!title || title && !title.length) {
        return null;
    }
    var matches = title.match(/[(](?:[^\d)]+[\/\\|])*((?:19|20|21)\d{2})/);
    if (!matches || matches && matches.length !== 2) {
        return null;
    }

    return +matches[1];
}

/**
 * Выбирает из массива поддерживаемое css свойство
 * http://www.developerdrive.com/2012/03/coding-vendor-prefixes-with-javascript/
 * @param {Object[]} properties - массив возможных поддерживаемых свойств
 * @return {String}
 */
function _nGetVendorPrefix(property) {
    if (!property || property && !_nCssProperties[property]) {
        return null;
    }
    var properties = _nCssProperties[property];
    var tmp = document.createElement('div');
    var result = null;
    for (var i = 0; i < properties.length; ++i) {
        if (typeof tmp.style[properties[i]] != 'undefined') {
            return properties[i];
        }
    }

    return result;
}

/**
 * Проверяет возможность использования localStorage
 * @param {Object} element - dom-элемент
 * @param {String} property - css-свойство
 * @return {Boolean}
 */
function _nComputedStyle(element, property) {
    if (typeof getComputedStyle !== 'undefined') {
        return getComputedStyle(element, null).getPropertyValue(property);
    } else {
        return element.currentStyle[property];
    }
}

/**
 * Проверяет возможность использования localStorage
 * @return {Boolean}
 */
function _nLocalStorage() {
    try {
        var storage = window['localStorage'];
        storage.setItem('_nTest', '_nTest');
        storage.removeItem('_nTest');

        return true;
    } catch(e) {
        return false;
    }
}

/**
 * Разбирает URL-параметры из адреса в объект с ключами - именами параметров, значения - значения параметров
 * @return {Object}
 */
function _nUrlParams() {
    var paramsArr = window.location.search.substr(1).split("&");
    if (paramsArr.length == 0) {
        return {};
    }
    var params = {};
    for (var i = 0; i < params.length; i++) {
        var pair = params[i].split("=");
        Object.defineProperty(params, pair[0].toLowerCase(), {
            enumerable: true,
            configurable: true,
            writable: true,
            value: decodeURIComponent(pair[1])
        });
    }

    return params;
}

/**
 * Формирует "тело" post-запроса
 * @param {Object[]} params - массив параметров "тела" запроса
 * @param {String} boundary
 * @return {String}
 */
function _nPostBody(params, boundary) {
    if (!params) {
        return '';
    }
    var boundaryMiddle = '--' + boundary + '\r\n';
    var boundaryLast = '--' + boundary + '--\r\n';
    var body = ['\r\n'];
    for (var key in params) {
        body.push('Content-Disposition: form-data; name="' + key + '"\r\n\r\n' + params[key] + '\r\n');
    }
    body = body.join(boundaryMiddle) + boundaryLast;

    return body;
}

/**
 * Удаляет cookie сторонних скриптов при загрузке страницы
 * @return {Void}
 */
function _nCookieReset() {
    // удаление cookie скрипта bookmarks.js
    if (!window._nUID)
    {
        _nCookieDelete('bookmarks_hash');
        _nCookieDelete('bookmarks_ids');
    }
}

/**
 * Получает значение cookie
 * @param {String} name - название cookie
 * @return {String}
 */
function _nCookieGet(name) {
    var matches = document.cookie.match(new RegExp("(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"));

    return matches ? decodeURIComponent(matches[1]) : undefined;
}

/**
 * Устанавливает cookie
 * @param {String} name - название cookie
 * @param {String} value - значение cookie
 * @param {Object[]} options - настройки
 * @return {Void}
 */
function _nCookieSet(name, value, options) {
    options = options || {};
    var expires = options.expires;
    if (typeof expires == "number" && expires) {
        var d = new Date();
        d.setTime(d.getTime() + expires * 1000);
        expires = options.expires = d;
    }
    if (expires && expires.toUTCString) {
        options.expires = expires.toUTCString();
    }
    value = encodeURIComponent(value);
    var updatedCookie = name + "=" + value;
    for (var propName in options) {
        updatedCookie += "; " + propName;
        var propValue = options[propName];
        if (propValue !== true) {
            updatedCookie += "=" + propValue;
        }
    }
    document.cookie = updatedCookie;
}

/**
 * Удаляет cookie
 * @param {String} name - название cookie
 * @return {Void}
 */
function _nCookieDelete(name) {
    _nCookieSet(name, '', {
        expires: -1
    });
}